// DO NOT EDIT. This file was autogenerated by parse.karyotype

// Package hg19 defines chromosome and band intervals for the human karyotype based on the hg19 assembly.
package hg19

import (
	"github.com/biogo/biogo/feat"
	"github.com/biogo/biogo/feat/genome"
)

var (
	Chr1  = genome.Chromosome{Chr: "Chr1", Desc: "Chromosome", Length: 249250621}
	Chr2  = genome.Chromosome{Chr: "Chr2", Desc: "Chromosome", Length: 243199373}
	Chr3  = genome.Chromosome{Chr: "Chr3", Desc: "Chromosome", Length: 198022430}
	Chr4  = genome.Chromosome{Chr: "Chr4", Desc: "Chromosome", Length: 191154276}
	Chr5  = genome.Chromosome{Chr: "Chr5", Desc: "Chromosome", Length: 180915260}
	Chr6  = genome.Chromosome{Chr: "Chr6", Desc: "Chromosome", Length: 171115067}
	Chr7  = genome.Chromosome{Chr: "Chr7", Desc: "Chromosome", Length: 159138663}
	Chr8  = genome.Chromosome{Chr: "Chr8", Desc: "Chromosome", Length: 146364022}
	Chr9  = genome.Chromosome{Chr: "Chr9", Desc: "Chromosome", Length: 141213431}
	Chr10 = genome.Chromosome{Chr: "Chr10", Desc: "Chromosome", Length: 135534747}
	Chr11 = genome.Chromosome{Chr: "Chr11", Desc: "Chromosome", Length: 135006516}
	Chr12 = genome.Chromosome{Chr: "Chr12", Desc: "Chromosome", Length: 133851895}
	Chr13 = genome.Chromosome{Chr: "Chr13", Desc: "Chromosome", Length: 115169878}
	Chr14 = genome.Chromosome{Chr: "Chr14", Desc: "Chromosome", Length: 107349540}
	Chr15 = genome.Chromosome{Chr: "Chr15", Desc: "Chromosome", Length: 102531392}
	Chr16 = genome.Chromosome{Chr: "Chr16", Desc: "Chromosome", Length: 90354753}
	Chr17 = genome.Chromosome{Chr: "Chr17", Desc: "Chromosome", Length: 81195210}
	Chr18 = genome.Chromosome{Chr: "Chr18", Desc: "Chromosome", Length: 78077248}
	Chr19 = genome.Chromosome{Chr: "Chr19", Desc: "Chromosome", Length: 59128983}
	Chr20 = genome.Chromosome{Chr: "Chr20", Desc: "Chromosome", Length: 63025520}
	Chr21 = genome.Chromosome{Chr: "Chr21", Desc: "Chromosome", Length: 48129895}
	Chr22 = genome.Chromosome{Chr: "Chr22", Desc: "Chromosome", Length: 51304566}
	ChrX  = genome.Chromosome{Chr: "ChrX", Desc: "Chromosome", Length: 155270560}
	ChrY  = genome.Chromosome{Chr: "ChrY", Desc: "Chromosome", Length: 59373566}
)

var Chromosomes = []*genome.Chromosome{
	&Chr1,
	&Chr2,
	&Chr3,
	&Chr4,
	&Chr5,
	&Chr6,
	&Chr7,
	&Chr8,
	&Chr9,
	&Chr10,
	&Chr11,
	&Chr12,
	&Chr13,
	&Chr14,
	&Chr15,
	&Chr16,
	&Chr17,
	&Chr18,
	&Chr19,
	&Chr20,
	&Chr21,
	&Chr22,
	&ChrX,
	&ChrY,
}

var (
	Chr1_p36_33  = genome.Band{Band: "p36.33", Desc: "Band", StartPos: 0, EndPos: 2300000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_p36_32  = genome.Band{Band: "p36.32", Desc: "Band", StartPos: 2300000, EndPos: 5400000, Giemsa: "gpos25", Chr: &Chr1}
	Chr1_p36_31  = genome.Band{Band: "p36.31", Desc: "Band", StartPos: 5400000, EndPos: 7200000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_p36_23  = genome.Band{Band: "p36.23", Desc: "Band", StartPos: 7200000, EndPos: 9200000, Giemsa: "gpos25", Chr: &Chr1}
	Chr1_p36_22  = genome.Band{Band: "p36.22", Desc: "Band", StartPos: 9200000, EndPos: 12700000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_p36_21  = genome.Band{Band: "p36.21", Desc: "Band", StartPos: 12700000, EndPos: 16200000, Giemsa: "gpos50", Chr: &Chr1}
	Chr1_p36_13  = genome.Band{Band: "p36.13", Desc: "Band", StartPos: 16200000, EndPos: 20400000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_p36_12  = genome.Band{Band: "p36.12", Desc: "Band", StartPos: 20400000, EndPos: 23900000, Giemsa: "gpos25", Chr: &Chr1}
	Chr1_p36_11  = genome.Band{Band: "p36.11", Desc: "Band", StartPos: 23900000, EndPos: 28000000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_p35_3   = genome.Band{Band: "p35.3", Desc: "Band", StartPos: 28000000, EndPos: 30200000, Giemsa: "gpos25", Chr: &Chr1}
	Chr1_p35_2   = genome.Band{Band: "p35.2", Desc: "Band", StartPos: 30200000, EndPos: 32400000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_p35_1   = genome.Band{Band: "p35.1", Desc: "Band", StartPos: 32400000, EndPos: 34600000, Giemsa: "gpos25", Chr: &Chr1}
	Chr1_p34_3   = genome.Band{Band: "p34.3", Desc: "Band", StartPos: 34600000, EndPos: 40100000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_p34_2   = genome.Band{Band: "p34.2", Desc: "Band", StartPos: 40100000, EndPos: 44100000, Giemsa: "gpos25", Chr: &Chr1}
	Chr1_p34_1   = genome.Band{Band: "p34.1", Desc: "Band", StartPos: 44100000, EndPos: 46800000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_p33     = genome.Band{Band: "p33", Desc: "Band", StartPos: 46800000, EndPos: 50700000, Giemsa: "gpos75", Chr: &Chr1}
	Chr1_p32_3   = genome.Band{Band: "p32.3", Desc: "Band", StartPos: 50700000, EndPos: 56100000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_p32_2   = genome.Band{Band: "p32.2", Desc: "Band", StartPos: 56100000, EndPos: 59000000, Giemsa: "gpos50", Chr: &Chr1}
	Chr1_p32_1   = genome.Band{Band: "p32.1", Desc: "Band", StartPos: 59000000, EndPos: 61300000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_p31_3   = genome.Band{Band: "p31.3", Desc: "Band", StartPos: 61300000, EndPos: 68900000, Giemsa: "gpos50", Chr: &Chr1}
	Chr1_p31_2   = genome.Band{Band: "p31.2", Desc: "Band", StartPos: 68900000, EndPos: 69700000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_p31_1   = genome.Band{Band: "p31.1", Desc: "Band", StartPos: 69700000, EndPos: 84900000, Giemsa: "gpos100", Chr: &Chr1}
	Chr1_p22_3   = genome.Band{Band: "p22.3", Desc: "Band", StartPos: 84900000, EndPos: 88400000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_p22_2   = genome.Band{Band: "p22.2", Desc: "Band", StartPos: 88400000, EndPos: 92000000, Giemsa: "gpos75", Chr: &Chr1}
	Chr1_p22_1   = genome.Band{Band: "p22.1", Desc: "Band", StartPos: 92000000, EndPos: 94700000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_p21_3   = genome.Band{Band: "p21.3", Desc: "Band", StartPos: 94700000, EndPos: 99700000, Giemsa: "gpos75", Chr: &Chr1}
	Chr1_p21_2   = genome.Band{Band: "p21.2", Desc: "Band", StartPos: 99700000, EndPos: 102200000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_p21_1   = genome.Band{Band: "p21.1", Desc: "Band", StartPos: 102200000, EndPos: 107200000, Giemsa: "gpos100", Chr: &Chr1}
	Chr1_p13_3   = genome.Band{Band: "p13.3", Desc: "Band", StartPos: 107200000, EndPos: 111800000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_p13_2   = genome.Band{Band: "p13.2", Desc: "Band", StartPos: 111800000, EndPos: 116100000, Giemsa: "gpos50", Chr: &Chr1}
	Chr1_p13_1   = genome.Band{Band: "p13.1", Desc: "Band", StartPos: 116100000, EndPos: 117800000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_p12     = genome.Band{Band: "p12", Desc: "Band", StartPos: 117800000, EndPos: 120600000, Giemsa: "gpos50", Chr: &Chr1}
	Chr1_p11_2   = genome.Band{Band: "p11.2", Desc: "Band", StartPos: 120600000, EndPos: 121500000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_p11_1   = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 121500000, EndPos: 125000000, Giemsa: "acen", Chr: &Chr1}
	Chr1_q11     = genome.Band{Band: "q11", Desc: "Band", StartPos: 125000000, EndPos: 128900000, Giemsa: "acen", Chr: &Chr1}
	Chr1_q12     = genome.Band{Band: "q12", Desc: "Band", StartPos: 128900000, EndPos: 142600000, Giemsa: "gvar", Chr: &Chr1}
	Chr1_q21_1   = genome.Band{Band: "q21.1", Desc: "Band", StartPos: 142600000, EndPos: 147000000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_q21_2   = genome.Band{Band: "q21.2", Desc: "Band", StartPos: 147000000, EndPos: 150300000, Giemsa: "gpos50", Chr: &Chr1}
	Chr1_q21_3   = genome.Band{Band: "q21.3", Desc: "Band", StartPos: 150300000, EndPos: 155000000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_q22     = genome.Band{Band: "q22", Desc: "Band", StartPos: 155000000, EndPos: 156500000, Giemsa: "gpos50", Chr: &Chr1}
	Chr1_q23_1   = genome.Band{Band: "q23.1", Desc: "Band", StartPos: 156500000, EndPos: 159100000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_q23_2   = genome.Band{Band: "q23.2", Desc: "Band", StartPos: 159100000, EndPos: 160500000, Giemsa: "gpos50", Chr: &Chr1}
	Chr1_q23_3   = genome.Band{Band: "q23.3", Desc: "Band", StartPos: 160500000, EndPos: 165500000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_q24_1   = genome.Band{Band: "q24.1", Desc: "Band", StartPos: 165500000, EndPos: 167200000, Giemsa: "gpos50", Chr: &Chr1}
	Chr1_q24_2   = genome.Band{Band: "q24.2", Desc: "Band", StartPos: 167200000, EndPos: 170900000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_q24_3   = genome.Band{Band: "q24.3", Desc: "Band", StartPos: 170900000, EndPos: 172900000, Giemsa: "gpos75", Chr: &Chr1}
	Chr1_q25_1   = genome.Band{Band: "q25.1", Desc: "Band", StartPos: 172900000, EndPos: 176000000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_q25_2   = genome.Band{Band: "q25.2", Desc: "Band", StartPos: 176000000, EndPos: 180300000, Giemsa: "gpos50", Chr: &Chr1}
	Chr1_q25_3   = genome.Band{Band: "q25.3", Desc: "Band", StartPos: 180300000, EndPos: 185800000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_q31_1   = genome.Band{Band: "q31.1", Desc: "Band", StartPos: 185800000, EndPos: 190800000, Giemsa: "gpos100", Chr: &Chr1}
	Chr1_q31_2   = genome.Band{Band: "q31.2", Desc: "Band", StartPos: 190800000, EndPos: 193800000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_q31_3   = genome.Band{Band: "q31.3", Desc: "Band", StartPos: 193800000, EndPos: 198700000, Giemsa: "gpos100", Chr: &Chr1}
	Chr1_q32_1   = genome.Band{Band: "q32.1", Desc: "Band", StartPos: 198700000, EndPos: 207200000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_q32_2   = genome.Band{Band: "q32.2", Desc: "Band", StartPos: 207200000, EndPos: 211500000, Giemsa: "gpos25", Chr: &Chr1}
	Chr1_q32_3   = genome.Band{Band: "q32.3", Desc: "Band", StartPos: 211500000, EndPos: 214500000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_q41     = genome.Band{Band: "q41", Desc: "Band", StartPos: 214500000, EndPos: 224100000, Giemsa: "gpos100", Chr: &Chr1}
	Chr1_q42_11  = genome.Band{Band: "q42.11", Desc: "Band", StartPos: 224100000, EndPos: 224600000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_q42_12  = genome.Band{Band: "q42.12", Desc: "Band", StartPos: 224600000, EndPos: 227000000, Giemsa: "gpos25", Chr: &Chr1}
	Chr1_q42_13  = genome.Band{Band: "q42.13", Desc: "Band", StartPos: 227000000, EndPos: 230700000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_q42_2   = genome.Band{Band: "q42.2", Desc: "Band", StartPos: 230700000, EndPos: 234700000, Giemsa: "gpos50", Chr: &Chr1}
	Chr1_q42_3   = genome.Band{Band: "q42.3", Desc: "Band", StartPos: 234700000, EndPos: 236600000, Giemsa: "gneg", Chr: &Chr1}
	Chr1_q43     = genome.Band{Band: "q43", Desc: "Band", StartPos: 236600000, EndPos: 243700000, Giemsa: "gpos75", Chr: &Chr1}
	Chr1_q44     = genome.Band{Band: "q44", Desc: "Band", StartPos: 243700000, EndPos: 249250621, Giemsa: "gneg", Chr: &Chr1}
	Chr2_p25_3   = genome.Band{Band: "p25.3", Desc: "Band", StartPos: 0, EndPos: 4400000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_p25_2   = genome.Band{Band: "p25.2", Desc: "Band", StartPos: 4400000, EndPos: 7100000, Giemsa: "gpos50", Chr: &Chr2}
	Chr2_p25_1   = genome.Band{Band: "p25.1", Desc: "Band", StartPos: 7100000, EndPos: 12200000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_p24_3   = genome.Band{Band: "p24.3", Desc: "Band", StartPos: 12200000, EndPos: 16700000, Giemsa: "gpos75", Chr: &Chr2}
	Chr2_p24_2   = genome.Band{Band: "p24.2", Desc: "Band", StartPos: 16700000, EndPos: 19200000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_p24_1   = genome.Band{Band: "p24.1", Desc: "Band", StartPos: 19200000, EndPos: 24000000, Giemsa: "gpos75", Chr: &Chr2}
	Chr2_p23_3   = genome.Band{Band: "p23.3", Desc: "Band", StartPos: 24000000, EndPos: 27900000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_p23_2   = genome.Band{Band: "p23.2", Desc: "Band", StartPos: 27900000, EndPos: 30000000, Giemsa: "gpos25", Chr: &Chr2}
	Chr2_p23_1   = genome.Band{Band: "p23.1", Desc: "Band", StartPos: 30000000, EndPos: 32100000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_p22_3   = genome.Band{Band: "p22.3", Desc: "Band", StartPos: 32100000, EndPos: 36600000, Giemsa: "gpos75", Chr: &Chr2}
	Chr2_p22_2   = genome.Band{Band: "p22.2", Desc: "Band", StartPos: 36600000, EndPos: 38600000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_p22_1   = genome.Band{Band: "p22.1", Desc: "Band", StartPos: 38600000, EndPos: 41800000, Giemsa: "gpos50", Chr: &Chr2}
	Chr2_p21     = genome.Band{Band: "p21", Desc: "Band", StartPos: 41800000, EndPos: 47800000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_p16_3   = genome.Band{Band: "p16.3", Desc: "Band", StartPos: 47800000, EndPos: 52900000, Giemsa: "gpos100", Chr: &Chr2}
	Chr2_p16_2   = genome.Band{Band: "p16.2", Desc: "Band", StartPos: 52900000, EndPos: 55000000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_p16_1   = genome.Band{Band: "p16.1", Desc: "Band", StartPos: 55000000, EndPos: 61300000, Giemsa: "gpos100", Chr: &Chr2}
	Chr2_p15     = genome.Band{Band: "p15", Desc: "Band", StartPos: 61300000, EndPos: 64100000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_p14     = genome.Band{Band: "p14", Desc: "Band", StartPos: 64100000, EndPos: 68600000, Giemsa: "gpos50", Chr: &Chr2}
	Chr2_p13_3   = genome.Band{Band: "p13.3", Desc: "Band", StartPos: 68600000, EndPos: 71500000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_p13_2   = genome.Band{Band: "p13.2", Desc: "Band", StartPos: 71500000, EndPos: 73500000, Giemsa: "gpos50", Chr: &Chr2}
	Chr2_p13_1   = genome.Band{Band: "p13.1", Desc: "Band", StartPos: 73500000, EndPos: 75000000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_p12     = genome.Band{Band: "p12", Desc: "Band", StartPos: 75000000, EndPos: 83300000, Giemsa: "gpos100", Chr: &Chr2}
	Chr2_p11_2   = genome.Band{Band: "p11.2", Desc: "Band", StartPos: 83300000, EndPos: 90500000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_p11_1   = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 90500000, EndPos: 93300000, Giemsa: "acen", Chr: &Chr2}
	Chr2_q11_1   = genome.Band{Band: "q11.1", Desc: "Band", StartPos: 93300000, EndPos: 96800000, Giemsa: "acen", Chr: &Chr2}
	Chr2_q11_2   = genome.Band{Band: "q11.2", Desc: "Band", StartPos: 96800000, EndPos: 102700000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_q12_1   = genome.Band{Band: "q12.1", Desc: "Band", StartPos: 102700000, EndPos: 106000000, Giemsa: "gpos50", Chr: &Chr2}
	Chr2_q12_2   = genome.Band{Band: "q12.2", Desc: "Band", StartPos: 106000000, EndPos: 107500000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_q12_3   = genome.Band{Band: "q12.3", Desc: "Band", StartPos: 107500000, EndPos: 110200000, Giemsa: "gpos25", Chr: &Chr2}
	Chr2_q13     = genome.Band{Band: "q13", Desc: "Band", StartPos: 110200000, EndPos: 114400000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_q14_1   = genome.Band{Band: "q14.1", Desc: "Band", StartPos: 114400000, EndPos: 118800000, Giemsa: "gpos50", Chr: &Chr2}
	Chr2_q14_2   = genome.Band{Band: "q14.2", Desc: "Band", StartPos: 118800000, EndPos: 122400000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_q14_3   = genome.Band{Band: "q14.3", Desc: "Band", StartPos: 122400000, EndPos: 129900000, Giemsa: "gpos50", Chr: &Chr2}
	Chr2_q21_1   = genome.Band{Band: "q21.1", Desc: "Band", StartPos: 129900000, EndPos: 132500000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_q21_2   = genome.Band{Band: "q21.2", Desc: "Band", StartPos: 132500000, EndPos: 135100000, Giemsa: "gpos25", Chr: &Chr2}
	Chr2_q21_3   = genome.Band{Band: "q21.3", Desc: "Band", StartPos: 135100000, EndPos: 136800000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_q22_1   = genome.Band{Band: "q22.1", Desc: "Band", StartPos: 136800000, EndPos: 142200000, Giemsa: "gpos100", Chr: &Chr2}
	Chr2_q22_2   = genome.Band{Band: "q22.2", Desc: "Band", StartPos: 142200000, EndPos: 144100000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_q22_3   = genome.Band{Band: "q22.3", Desc: "Band", StartPos: 144100000, EndPos: 148700000, Giemsa: "gpos100", Chr: &Chr2}
	Chr2_q23_1   = genome.Band{Band: "q23.1", Desc: "Band", StartPos: 148700000, EndPos: 149900000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_q23_2   = genome.Band{Band: "q23.2", Desc: "Band", StartPos: 149900000, EndPos: 150500000, Giemsa: "gpos25", Chr: &Chr2}
	Chr2_q23_3   = genome.Band{Band: "q23.3", Desc: "Band", StartPos: 150500000, EndPos: 154900000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_q24_1   = genome.Band{Band: "q24.1", Desc: "Band", StartPos: 154900000, EndPos: 159800000, Giemsa: "gpos75", Chr: &Chr2}
	Chr2_q24_2   = genome.Band{Band: "q24.2", Desc: "Band", StartPos: 159800000, EndPos: 163700000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_q24_3   = genome.Band{Band: "q24.3", Desc: "Band", StartPos: 163700000, EndPos: 169700000, Giemsa: "gpos75", Chr: &Chr2}
	Chr2_q31_1   = genome.Band{Band: "q31.1", Desc: "Band", StartPos: 169700000, EndPos: 178000000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_q31_2   = genome.Band{Band: "q31.2", Desc: "Band", StartPos: 178000000, EndPos: 180600000, Giemsa: "gpos50", Chr: &Chr2}
	Chr2_q31_3   = genome.Band{Band: "q31.3", Desc: "Band", StartPos: 180600000, EndPos: 183000000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_q32_1   = genome.Band{Band: "q32.1", Desc: "Band", StartPos: 183000000, EndPos: 189400000, Giemsa: "gpos75", Chr: &Chr2}
	Chr2_q32_2   = genome.Band{Band: "q32.2", Desc: "Band", StartPos: 189400000, EndPos: 191900000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_q32_3   = genome.Band{Band: "q32.3", Desc: "Band", StartPos: 191900000, EndPos: 197400000, Giemsa: "gpos75", Chr: &Chr2}
	Chr2_q33_1   = genome.Band{Band: "q33.1", Desc: "Band", StartPos: 197400000, EndPos: 203300000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_q33_2   = genome.Band{Band: "q33.2", Desc: "Band", StartPos: 203300000, EndPos: 204900000, Giemsa: "gpos50", Chr: &Chr2}
	Chr2_q33_3   = genome.Band{Band: "q33.3", Desc: "Band", StartPos: 204900000, EndPos: 209000000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_q34     = genome.Band{Band: "q34", Desc: "Band", StartPos: 209000000, EndPos: 215300000, Giemsa: "gpos100", Chr: &Chr2}
	Chr2_q35     = genome.Band{Band: "q35", Desc: "Band", StartPos: 215300000, EndPos: 221500000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_q36_1   = genome.Band{Band: "q36.1", Desc: "Band", StartPos: 221500000, EndPos: 225200000, Giemsa: "gpos75", Chr: &Chr2}
	Chr2_q36_2   = genome.Band{Band: "q36.2", Desc: "Band", StartPos: 225200000, EndPos: 226100000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_q36_3   = genome.Band{Band: "q36.3", Desc: "Band", StartPos: 226100000, EndPos: 231000000, Giemsa: "gpos100", Chr: &Chr2}
	Chr2_q37_1   = genome.Band{Band: "q37.1", Desc: "Band", StartPos: 231000000, EndPos: 235600000, Giemsa: "gneg", Chr: &Chr2}
	Chr2_q37_2   = genome.Band{Band: "q37.2", Desc: "Band", StartPos: 235600000, EndPos: 237300000, Giemsa: "gpos50", Chr: &Chr2}
	Chr2_q37_3   = genome.Band{Band: "q37.3", Desc: "Band", StartPos: 237300000, EndPos: 243199373, Giemsa: "gneg", Chr: &Chr2}
	Chr3_p26_3   = genome.Band{Band: "p26.3", Desc: "Band", StartPos: 0, EndPos: 2800000, Giemsa: "gpos50", Chr: &Chr3}
	Chr3_p26_2   = genome.Band{Band: "p26.2", Desc: "Band", StartPos: 2800000, EndPos: 4000000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_p26_1   = genome.Band{Band: "p26.1", Desc: "Band", StartPos: 4000000, EndPos: 8700000, Giemsa: "gpos50", Chr: &Chr3}
	Chr3_p25_3   = genome.Band{Band: "p25.3", Desc: "Band", StartPos: 8700000, EndPos: 11800000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_p25_2   = genome.Band{Band: "p25.2", Desc: "Band", StartPos: 11800000, EndPos: 13300000, Giemsa: "gpos25", Chr: &Chr3}
	Chr3_p25_1   = genome.Band{Band: "p25.1", Desc: "Band", StartPos: 13300000, EndPos: 16400000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_p24_3   = genome.Band{Band: "p24.3", Desc: "Band", StartPos: 16400000, EndPos: 23900000, Giemsa: "gpos100", Chr: &Chr3}
	Chr3_p24_2   = genome.Band{Band: "p24.2", Desc: "Band", StartPos: 23900000, EndPos: 26400000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_p24_1   = genome.Band{Band: "p24.1", Desc: "Band", StartPos: 26400000, EndPos: 30900000, Giemsa: "gpos75", Chr: &Chr3}
	Chr3_p23     = genome.Band{Band: "p23", Desc: "Band", StartPos: 30900000, EndPos: 32100000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_p22_3   = genome.Band{Band: "p22.3", Desc: "Band", StartPos: 32100000, EndPos: 36500000, Giemsa: "gpos50", Chr: &Chr3}
	Chr3_p22_2   = genome.Band{Band: "p22.2", Desc: "Band", StartPos: 36500000, EndPos: 39400000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_p22_1   = genome.Band{Band: "p22.1", Desc: "Band", StartPos: 39400000, EndPos: 43700000, Giemsa: "gpos75", Chr: &Chr3}
	Chr3_p21_33  = genome.Band{Band: "p21.33", Desc: "Band", StartPos: 43700000, EndPos: 44100000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_p21_32  = genome.Band{Band: "p21.32", Desc: "Band", StartPos: 44100000, EndPos: 44200000, Giemsa: "gpos50", Chr: &Chr3}
	Chr3_p21_31  = genome.Band{Band: "p21.31", Desc: "Band", StartPos: 44200000, EndPos: 50600000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_p21_2   = genome.Band{Band: "p21.2", Desc: "Band", StartPos: 50600000, EndPos: 52300000, Giemsa: "gpos25", Chr: &Chr3}
	Chr3_p21_1   = genome.Band{Band: "p21.1", Desc: "Band", StartPos: 52300000, EndPos: 54400000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_p14_3   = genome.Band{Band: "p14.3", Desc: "Band", StartPos: 54400000, EndPos: 58600000, Giemsa: "gpos50", Chr: &Chr3}
	Chr3_p14_2   = genome.Band{Band: "p14.2", Desc: "Band", StartPos: 58600000, EndPos: 63700000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_p14_1   = genome.Band{Band: "p14.1", Desc: "Band", StartPos: 63700000, EndPos: 69800000, Giemsa: "gpos50", Chr: &Chr3}
	Chr3_p13     = genome.Band{Band: "p13", Desc: "Band", StartPos: 69800000, EndPos: 74200000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_p12_3   = genome.Band{Band: "p12.3", Desc: "Band", StartPos: 74200000, EndPos: 79800000, Giemsa: "gpos75", Chr: &Chr3}
	Chr3_p12_2   = genome.Band{Band: "p12.2", Desc: "Band", StartPos: 79800000, EndPos: 83500000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_p12_1   = genome.Band{Band: "p12.1", Desc: "Band", StartPos: 83500000, EndPos: 87200000, Giemsa: "gpos75", Chr: &Chr3}
	Chr3_p11_2   = genome.Band{Band: "p11.2", Desc: "Band", StartPos: 87200000, EndPos: 87900000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_p11_1   = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 87900000, EndPos: 91000000, Giemsa: "acen", Chr: &Chr3}
	Chr3_q11_1   = genome.Band{Band: "q11.1", Desc: "Band", StartPos: 91000000, EndPos: 93900000, Giemsa: "acen", Chr: &Chr3}
	Chr3_q11_2   = genome.Band{Band: "q11.2", Desc: "Band", StartPos: 93900000, EndPos: 98300000, Giemsa: "gvar", Chr: &Chr3}
	Chr3_q12_1   = genome.Band{Band: "q12.1", Desc: "Band", StartPos: 98300000, EndPos: 100000000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_q12_2   = genome.Band{Band: "q12.2", Desc: "Band", StartPos: 100000000, EndPos: 100900000, Giemsa: "gpos25", Chr: &Chr3}
	Chr3_q12_3   = genome.Band{Band: "q12.3", Desc: "Band", StartPos: 100900000, EndPos: 102800000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_q13_11  = genome.Band{Band: "q13.11", Desc: "Band", StartPos: 102800000, EndPos: 106200000, Giemsa: "gpos75", Chr: &Chr3}
	Chr3_q13_12  = genome.Band{Band: "q13.12", Desc: "Band", StartPos: 106200000, EndPos: 107900000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_q13_13  = genome.Band{Band: "q13.13", Desc: "Band", StartPos: 107900000, EndPos: 111300000, Giemsa: "gpos50", Chr: &Chr3}
	Chr3_q13_2   = genome.Band{Band: "q13.2", Desc: "Band", StartPos: 111300000, EndPos: 113500000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_q13_31  = genome.Band{Band: "q13.31", Desc: "Band", StartPos: 113500000, EndPos: 117300000, Giemsa: "gpos75", Chr: &Chr3}
	Chr3_q13_32  = genome.Band{Band: "q13.32", Desc: "Band", StartPos: 117300000, EndPos: 119000000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_q13_33  = genome.Band{Band: "q13.33", Desc: "Band", StartPos: 119000000, EndPos: 121900000, Giemsa: "gpos75", Chr: &Chr3}
	Chr3_q21_1   = genome.Band{Band: "q21.1", Desc: "Band", StartPos: 121900000, EndPos: 123800000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_q21_2   = genome.Band{Band: "q21.2", Desc: "Band", StartPos: 123800000, EndPos: 125800000, Giemsa: "gpos25", Chr: &Chr3}
	Chr3_q21_3   = genome.Band{Band: "q21.3", Desc: "Band", StartPos: 125800000, EndPos: 129200000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_q22_1   = genome.Band{Band: "q22.1", Desc: "Band", StartPos: 129200000, EndPos: 133700000, Giemsa: "gpos25", Chr: &Chr3}
	Chr3_q22_2   = genome.Band{Band: "q22.2", Desc: "Band", StartPos: 133700000, EndPos: 135700000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_q22_3   = genome.Band{Band: "q22.3", Desc: "Band", StartPos: 135700000, EndPos: 138700000, Giemsa: "gpos25", Chr: &Chr3}
	Chr3_q23     = genome.Band{Band: "q23", Desc: "Band", StartPos: 138700000, EndPos: 142800000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_q24     = genome.Band{Band: "q24", Desc: "Band", StartPos: 142800000, EndPos: 148900000, Giemsa: "gpos100", Chr: &Chr3}
	Chr3_q25_1   = genome.Band{Band: "q25.1", Desc: "Band", StartPos: 148900000, EndPos: 152100000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_q25_2   = genome.Band{Band: "q25.2", Desc: "Band", StartPos: 152100000, EndPos: 155000000, Giemsa: "gpos50", Chr: &Chr3}
	Chr3_q25_31  = genome.Band{Band: "q25.31", Desc: "Band", StartPos: 155000000, EndPos: 157000000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_q25_32  = genome.Band{Band: "q25.32", Desc: "Band", StartPos: 157000000, EndPos: 159000000, Giemsa: "gpos50", Chr: &Chr3}
	Chr3_q25_33  = genome.Band{Band: "q25.33", Desc: "Band", StartPos: 159000000, EndPos: 160700000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_q26_1   = genome.Band{Band: "q26.1", Desc: "Band", StartPos: 160700000, EndPos: 167600000, Giemsa: "gpos100", Chr: &Chr3}
	Chr3_q26_2   = genome.Band{Band: "q26.2", Desc: "Band", StartPos: 167600000, EndPos: 170900000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_q26_31  = genome.Band{Band: "q26.31", Desc: "Band", StartPos: 170900000, EndPos: 175700000, Giemsa: "gpos75", Chr: &Chr3}
	Chr3_q26_32  = genome.Band{Band: "q26.32", Desc: "Band", StartPos: 175700000, EndPos: 179000000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_q26_33  = genome.Band{Band: "q26.33", Desc: "Band", StartPos: 179000000, EndPos: 182700000, Giemsa: "gpos75", Chr: &Chr3}
	Chr3_q27_1   = genome.Band{Band: "q27.1", Desc: "Band", StartPos: 182700000, EndPos: 184500000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_q27_2   = genome.Band{Band: "q27.2", Desc: "Band", StartPos: 184500000, EndPos: 186000000, Giemsa: "gpos25", Chr: &Chr3}
	Chr3_q27_3   = genome.Band{Band: "q27.3", Desc: "Band", StartPos: 186000000, EndPos: 187900000, Giemsa: "gneg", Chr: &Chr3}
	Chr3_q28     = genome.Band{Band: "q28", Desc: "Band", StartPos: 187900000, EndPos: 192300000, Giemsa: "gpos75", Chr: &Chr3}
	Chr3_q29     = genome.Band{Band: "q29", Desc: "Band", StartPos: 192300000, EndPos: 198022430, Giemsa: "gneg", Chr: &Chr3}
	Chr4_p16_3   = genome.Band{Band: "p16.3", Desc: "Band", StartPos: 0, EndPos: 4500000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_p16_2   = genome.Band{Band: "p16.2", Desc: "Band", StartPos: 4500000, EndPos: 6000000, Giemsa: "gpos25", Chr: &Chr4}
	Chr4_p16_1   = genome.Band{Band: "p16.1", Desc: "Band", StartPos: 6000000, EndPos: 11300000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_p15_33  = genome.Band{Band: "p15.33", Desc: "Band", StartPos: 11300000, EndPos: 15200000, Giemsa: "gpos50", Chr: &Chr4}
	Chr4_p15_32  = genome.Band{Band: "p15.32", Desc: "Band", StartPos: 15200000, EndPos: 17800000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_p15_31  = genome.Band{Band: "p15.31", Desc: "Band", StartPos: 17800000, EndPos: 21300000, Giemsa: "gpos75", Chr: &Chr4}
	Chr4_p15_2   = genome.Band{Band: "p15.2", Desc: "Band", StartPos: 21300000, EndPos: 27700000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_p15_1   = genome.Band{Band: "p15.1", Desc: "Band", StartPos: 27700000, EndPos: 35800000, Giemsa: "gpos100", Chr: &Chr4}
	Chr4_p14     = genome.Band{Band: "p14", Desc: "Band", StartPos: 35800000, EndPos: 41200000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_p13     = genome.Band{Band: "p13", Desc: "Band", StartPos: 41200000, EndPos: 44600000, Giemsa: "gpos50", Chr: &Chr4}
	Chr4_p12     = genome.Band{Band: "p12", Desc: "Band", StartPos: 44600000, EndPos: 48200000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_p11     = genome.Band{Band: "p11", Desc: "Band", StartPos: 48200000, EndPos: 50400000, Giemsa: "acen", Chr: &Chr4}
	Chr4_q11     = genome.Band{Band: "q11", Desc: "Band", StartPos: 50400000, EndPos: 52700000, Giemsa: "acen", Chr: &Chr4}
	Chr4_q12     = genome.Band{Band: "q12", Desc: "Band", StartPos: 52700000, EndPos: 59500000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_q13_1   = genome.Band{Band: "q13.1", Desc: "Band", StartPos: 59500000, EndPos: 66600000, Giemsa: "gpos100", Chr: &Chr4}
	Chr4_q13_2   = genome.Band{Band: "q13.2", Desc: "Band", StartPos: 66600000, EndPos: 70500000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_q13_3   = genome.Band{Band: "q13.3", Desc: "Band", StartPos: 70500000, EndPos: 76300000, Giemsa: "gpos75", Chr: &Chr4}
	Chr4_q21_1   = genome.Band{Band: "q21.1", Desc: "Band", StartPos: 76300000, EndPos: 78900000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_q21_21  = genome.Band{Band: "q21.21", Desc: "Band", StartPos: 78900000, EndPos: 82400000, Giemsa: "gpos50", Chr: &Chr4}
	Chr4_q21_22  = genome.Band{Band: "q21.22", Desc: "Band", StartPos: 82400000, EndPos: 84100000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_q21_23  = genome.Band{Band: "q21.23", Desc: "Band", StartPos: 84100000, EndPos: 86900000, Giemsa: "gpos25", Chr: &Chr4}
	Chr4_q21_3   = genome.Band{Band: "q21.3", Desc: "Band", StartPos: 86900000, EndPos: 88000000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_q22_1   = genome.Band{Band: "q22.1", Desc: "Band", StartPos: 88000000, EndPos: 93700000, Giemsa: "gpos75", Chr: &Chr4}
	Chr4_q22_2   = genome.Band{Band: "q22.2", Desc: "Band", StartPos: 93700000, EndPos: 95100000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_q22_3   = genome.Band{Band: "q22.3", Desc: "Band", StartPos: 95100000, EndPos: 98800000, Giemsa: "gpos75", Chr: &Chr4}
	Chr4_q23     = genome.Band{Band: "q23", Desc: "Band", StartPos: 98800000, EndPos: 101100000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_q24     = genome.Band{Band: "q24", Desc: "Band", StartPos: 101100000, EndPos: 107700000, Giemsa: "gpos50", Chr: &Chr4}
	Chr4_q25     = genome.Band{Band: "q25", Desc: "Band", StartPos: 107700000, EndPos: 114100000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_q26     = genome.Band{Band: "q26", Desc: "Band", StartPos: 114100000, EndPos: 120800000, Giemsa: "gpos75", Chr: &Chr4}
	Chr4_q27     = genome.Band{Band: "q27", Desc: "Band", StartPos: 120800000, EndPos: 123800000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_q28_1   = genome.Band{Band: "q28.1", Desc: "Band", StartPos: 123800000, EndPos: 128800000, Giemsa: "gpos50", Chr: &Chr4}
	Chr4_q28_2   = genome.Band{Band: "q28.2", Desc: "Band", StartPos: 128800000, EndPos: 131100000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_q28_3   = genome.Band{Band: "q28.3", Desc: "Band", StartPos: 131100000, EndPos: 139500000, Giemsa: "gpos100", Chr: &Chr4}
	Chr4_q31_1   = genome.Band{Band: "q31.1", Desc: "Band", StartPos: 139500000, EndPos: 141500000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_q31_21  = genome.Band{Band: "q31.21", Desc: "Band", StartPos: 141500000, EndPos: 146800000, Giemsa: "gpos25", Chr: &Chr4}
	Chr4_q31_22  = genome.Band{Band: "q31.22", Desc: "Band", StartPos: 146800000, EndPos: 148500000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_q31_23  = genome.Band{Band: "q31.23", Desc: "Band", StartPos: 148500000, EndPos: 151100000, Giemsa: "gpos25", Chr: &Chr4}
	Chr4_q31_3   = genome.Band{Band: "q31.3", Desc: "Band", StartPos: 151100000, EndPos: 155600000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_q32_1   = genome.Band{Band: "q32.1", Desc: "Band", StartPos: 155600000, EndPos: 161800000, Giemsa: "gpos100", Chr: &Chr4}
	Chr4_q32_2   = genome.Band{Band: "q32.2", Desc: "Band", StartPos: 161800000, EndPos: 164500000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_q32_3   = genome.Band{Band: "q32.3", Desc: "Band", StartPos: 164500000, EndPos: 170100000, Giemsa: "gpos100", Chr: &Chr4}
	Chr4_q33     = genome.Band{Band: "q33", Desc: "Band", StartPos: 170100000, EndPos: 171900000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_q34_1   = genome.Band{Band: "q34.1", Desc: "Band", StartPos: 171900000, EndPos: 176300000, Giemsa: "gpos75", Chr: &Chr4}
	Chr4_q34_2   = genome.Band{Band: "q34.2", Desc: "Band", StartPos: 176300000, EndPos: 177500000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_q34_3   = genome.Band{Band: "q34.3", Desc: "Band", StartPos: 177500000, EndPos: 183200000, Giemsa: "gpos100", Chr: &Chr4}
	Chr4_q35_1   = genome.Band{Band: "q35.1", Desc: "Band", StartPos: 183200000, EndPos: 187100000, Giemsa: "gneg", Chr: &Chr4}
	Chr4_q35_2   = genome.Band{Band: "q35.2", Desc: "Band", StartPos: 187100000, EndPos: 191154276, Giemsa: "gpos25", Chr: &Chr4}
	Chr5_p15_33  = genome.Band{Band: "p15.33", Desc: "Band", StartPos: 0, EndPos: 4500000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_p15_32  = genome.Band{Band: "p15.32", Desc: "Band", StartPos: 4500000, EndPos: 6300000, Giemsa: "gpos25", Chr: &Chr5}
	Chr5_p15_31  = genome.Band{Band: "p15.31", Desc: "Band", StartPos: 6300000, EndPos: 9800000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_p15_2   = genome.Band{Band: "p15.2", Desc: "Band", StartPos: 9800000, EndPos: 15000000, Giemsa: "gpos50", Chr: &Chr5}
	Chr5_p15_1   = genome.Band{Band: "p15.1", Desc: "Band", StartPos: 15000000, EndPos: 18400000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_p14_3   = genome.Band{Band: "p14.3", Desc: "Band", StartPos: 18400000, EndPos: 23300000, Giemsa: "gpos100", Chr: &Chr5}
	Chr5_p14_2   = genome.Band{Band: "p14.2", Desc: "Band", StartPos: 23300000, EndPos: 24600000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_p14_1   = genome.Band{Band: "p14.1", Desc: "Band", StartPos: 24600000, EndPos: 28900000, Giemsa: "gpos100", Chr: &Chr5}
	Chr5_p13_3   = genome.Band{Band: "p13.3", Desc: "Band", StartPos: 28900000, EndPos: 33800000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_p13_2   = genome.Band{Band: "p13.2", Desc: "Band", StartPos: 33800000, EndPos: 38400000, Giemsa: "gpos25", Chr: &Chr5}
	Chr5_p13_1   = genome.Band{Band: "p13.1", Desc: "Band", StartPos: 38400000, EndPos: 42500000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_p12     = genome.Band{Band: "p12", Desc: "Band", StartPos: 42500000, EndPos: 46100000, Giemsa: "gpos50", Chr: &Chr5}
	Chr5_p11     = genome.Band{Band: "p11", Desc: "Band", StartPos: 46100000, EndPos: 48400000, Giemsa: "acen", Chr: &Chr5}
	Chr5_q11_1   = genome.Band{Band: "q11.1", Desc: "Band", StartPos: 48400000, EndPos: 50700000, Giemsa: "acen", Chr: &Chr5}
	Chr5_q11_2   = genome.Band{Band: "q11.2", Desc: "Band", StartPos: 50700000, EndPos: 58900000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_q12_1   = genome.Band{Band: "q12.1", Desc: "Band", StartPos: 58900000, EndPos: 62900000, Giemsa: "gpos75", Chr: &Chr5}
	Chr5_q12_2   = genome.Band{Band: "q12.2", Desc: "Band", StartPos: 62900000, EndPos: 63200000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_q12_3   = genome.Band{Band: "q12.3", Desc: "Band", StartPos: 63200000, EndPos: 66700000, Giemsa: "gpos75", Chr: &Chr5}
	Chr5_q13_1   = genome.Band{Band: "q13.1", Desc: "Band", StartPos: 66700000, EndPos: 68400000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_q13_2   = genome.Band{Band: "q13.2", Desc: "Band", StartPos: 68400000, EndPos: 73300000, Giemsa: "gpos50", Chr: &Chr5}
	Chr5_q13_3   = genome.Band{Band: "q13.3", Desc: "Band", StartPos: 73300000, EndPos: 76900000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_q14_1   = genome.Band{Band: "q14.1", Desc: "Band", StartPos: 76900000, EndPos: 81400000, Giemsa: "gpos50", Chr: &Chr5}
	Chr5_q14_2   = genome.Band{Band: "q14.2", Desc: "Band", StartPos: 81400000, EndPos: 82800000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_q14_3   = genome.Band{Band: "q14.3", Desc: "Band", StartPos: 82800000, EndPos: 92300000, Giemsa: "gpos100", Chr: &Chr5}
	Chr5_q15     = genome.Band{Band: "q15", Desc: "Band", StartPos: 92300000, EndPos: 98200000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_q21_1   = genome.Band{Band: "q21.1", Desc: "Band", StartPos: 98200000, EndPos: 102800000, Giemsa: "gpos100", Chr: &Chr5}
	Chr5_q21_2   = genome.Band{Band: "q21.2", Desc: "Band", StartPos: 102800000, EndPos: 104500000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_q21_3   = genome.Band{Band: "q21.3", Desc: "Band", StartPos: 104500000, EndPos: 109600000, Giemsa: "gpos100", Chr: &Chr5}
	Chr5_q22_1   = genome.Band{Band: "q22.1", Desc: "Band", StartPos: 109600000, EndPos: 111500000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_q22_2   = genome.Band{Band: "q22.2", Desc: "Band", StartPos: 111500000, EndPos: 113100000, Giemsa: "gpos50", Chr: &Chr5}
	Chr5_q22_3   = genome.Band{Band: "q22.3", Desc: "Band", StartPos: 113100000, EndPos: 115200000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_q23_1   = genome.Band{Band: "q23.1", Desc: "Band", StartPos: 115200000, EndPos: 121400000, Giemsa: "gpos100", Chr: &Chr5}
	Chr5_q23_2   = genome.Band{Band: "q23.2", Desc: "Band", StartPos: 121400000, EndPos: 127300000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_q23_3   = genome.Band{Band: "q23.3", Desc: "Band", StartPos: 127300000, EndPos: 130600000, Giemsa: "gpos100", Chr: &Chr5}
	Chr5_q31_1   = genome.Band{Band: "q31.1", Desc: "Band", StartPos: 130600000, EndPos: 136200000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_q31_2   = genome.Band{Band: "q31.2", Desc: "Band", StartPos: 136200000, EndPos: 139500000, Giemsa: "gpos25", Chr: &Chr5}
	Chr5_q31_3   = genome.Band{Band: "q31.3", Desc: "Band", StartPos: 139500000, EndPos: 144500000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_q32     = genome.Band{Band: "q32", Desc: "Band", StartPos: 144500000, EndPos: 149800000, Giemsa: "gpos75", Chr: &Chr5}
	Chr5_q33_1   = genome.Band{Band: "q33.1", Desc: "Band", StartPos: 149800000, EndPos: 152700000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_q33_2   = genome.Band{Band: "q33.2", Desc: "Band", StartPos: 152700000, EndPos: 155700000, Giemsa: "gpos50", Chr: &Chr5}
	Chr5_q33_3   = genome.Band{Band: "q33.3", Desc: "Band", StartPos: 155700000, EndPos: 159900000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_q34     = genome.Band{Band: "q34", Desc: "Band", StartPos: 159900000, EndPos: 168500000, Giemsa: "gpos100", Chr: &Chr5}
	Chr5_q35_1   = genome.Band{Band: "q35.1", Desc: "Band", StartPos: 168500000, EndPos: 172800000, Giemsa: "gneg", Chr: &Chr5}
	Chr5_q35_2   = genome.Band{Band: "q35.2", Desc: "Band", StartPos: 172800000, EndPos: 176600000, Giemsa: "gpos25", Chr: &Chr5}
	Chr5_q35_3   = genome.Band{Band: "q35.3", Desc: "Band", StartPos: 176600000, EndPos: 180915260, Giemsa: "gneg", Chr: &Chr5}
	Chr6_p25_3   = genome.Band{Band: "p25.3", Desc: "Band", StartPos: 0, EndPos: 2300000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_p25_2   = genome.Band{Band: "p25.2", Desc: "Band", StartPos: 2300000, EndPos: 4200000, Giemsa: "gpos25", Chr: &Chr6}
	Chr6_p25_1   = genome.Band{Band: "p25.1", Desc: "Band", StartPos: 4200000, EndPos: 7100000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_p24_3   = genome.Band{Band: "p24.3", Desc: "Band", StartPos: 7100000, EndPos: 10600000, Giemsa: "gpos50", Chr: &Chr6}
	Chr6_p24_2   = genome.Band{Band: "p24.2", Desc: "Band", StartPos: 10600000, EndPos: 11600000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_p24_1   = genome.Band{Band: "p24.1", Desc: "Band", StartPos: 11600000, EndPos: 13400000, Giemsa: "gpos25", Chr: &Chr6}
	Chr6_p23     = genome.Band{Band: "p23", Desc: "Band", StartPos: 13400000, EndPos: 15200000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_p22_3   = genome.Band{Band: "p22.3", Desc: "Band", StartPos: 15200000, EndPos: 25200000, Giemsa: "gpos75", Chr: &Chr6}
	Chr6_p22_2   = genome.Band{Band: "p22.2", Desc: "Band", StartPos: 25200000, EndPos: 27000000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_p22_1   = genome.Band{Band: "p22.1", Desc: "Band", StartPos: 27000000, EndPos: 30400000, Giemsa: "gpos50", Chr: &Chr6}
	Chr6_p21_33  = genome.Band{Band: "p21.33", Desc: "Band", StartPos: 30400000, EndPos: 32100000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_p21_32  = genome.Band{Band: "p21.32", Desc: "Band", StartPos: 32100000, EndPos: 33500000, Giemsa: "gpos25", Chr: &Chr6}
	Chr6_p21_31  = genome.Band{Band: "p21.31", Desc: "Band", StartPos: 33500000, EndPos: 36600000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_p21_2   = genome.Band{Band: "p21.2", Desc: "Band", StartPos: 36600000, EndPos: 40500000, Giemsa: "gpos25", Chr: &Chr6}
	Chr6_p21_1   = genome.Band{Band: "p21.1", Desc: "Band", StartPos: 40500000, EndPos: 46200000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_p12_3   = genome.Band{Band: "p12.3", Desc: "Band", StartPos: 46200000, EndPos: 51800000, Giemsa: "gpos100", Chr: &Chr6}
	Chr6_p12_2   = genome.Band{Band: "p12.2", Desc: "Band", StartPos: 51800000, EndPos: 52900000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_p12_1   = genome.Band{Band: "p12.1", Desc: "Band", StartPos: 52900000, EndPos: 57000000, Giemsa: "gpos100", Chr: &Chr6}
	Chr6_p11_2   = genome.Band{Band: "p11.2", Desc: "Band", StartPos: 57000000, EndPos: 58700000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_p11_1   = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 58700000, EndPos: 61000000, Giemsa: "acen", Chr: &Chr6}
	Chr6_q11_1   = genome.Band{Band: "q11.1", Desc: "Band", StartPos: 61000000, EndPos: 63300000, Giemsa: "acen", Chr: &Chr6}
	Chr6_q11_2   = genome.Band{Band: "q11.2", Desc: "Band", StartPos: 63300000, EndPos: 63400000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_q12     = genome.Band{Band: "q12", Desc: "Band", StartPos: 63400000, EndPos: 70000000, Giemsa: "gpos100", Chr: &Chr6}
	Chr6_q13     = genome.Band{Band: "q13", Desc: "Band", StartPos: 70000000, EndPos: 75900000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_q14_1   = genome.Band{Band: "q14.1", Desc: "Band", StartPos: 75900000, EndPos: 83900000, Giemsa: "gpos50", Chr: &Chr6}
	Chr6_q14_2   = genome.Band{Band: "q14.2", Desc: "Band", StartPos: 83900000, EndPos: 84900000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_q14_3   = genome.Band{Band: "q14.3", Desc: "Band", StartPos: 84900000, EndPos: 88000000, Giemsa: "gpos50", Chr: &Chr6}
	Chr6_q15     = genome.Band{Band: "q15", Desc: "Band", StartPos: 88000000, EndPos: 93100000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_q16_1   = genome.Band{Band: "q16.1", Desc: "Band", StartPos: 93100000, EndPos: 99500000, Giemsa: "gpos100", Chr: &Chr6}
	Chr6_q16_2   = genome.Band{Band: "q16.2", Desc: "Band", StartPos: 99500000, EndPos: 100600000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_q16_3   = genome.Band{Band: "q16.3", Desc: "Band", StartPos: 100600000, EndPos: 105500000, Giemsa: "gpos100", Chr: &Chr6}
	Chr6_q21     = genome.Band{Band: "q21", Desc: "Band", StartPos: 105500000, EndPos: 114600000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_q22_1   = genome.Band{Band: "q22.1", Desc: "Band", StartPos: 114600000, EndPos: 118300000, Giemsa: "gpos75", Chr: &Chr6}
	Chr6_q22_2   = genome.Band{Band: "q22.2", Desc: "Band", StartPos: 118300000, EndPos: 118500000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_q22_31  = genome.Band{Band: "q22.31", Desc: "Band", StartPos: 118500000, EndPos: 126100000, Giemsa: "gpos100", Chr: &Chr6}
	Chr6_q22_32  = genome.Band{Band: "q22.32", Desc: "Band", StartPos: 126100000, EndPos: 127100000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_q22_33  = genome.Band{Band: "q22.33", Desc: "Band", StartPos: 127100000, EndPos: 130300000, Giemsa: "gpos75", Chr: &Chr6}
	Chr6_q23_1   = genome.Band{Band: "q23.1", Desc: "Band", StartPos: 130300000, EndPos: 131200000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_q23_2   = genome.Band{Band: "q23.2", Desc: "Band", StartPos: 131200000, EndPos: 135200000, Giemsa: "gpos50", Chr: &Chr6}
	Chr6_q23_3   = genome.Band{Band: "q23.3", Desc: "Band", StartPos: 135200000, EndPos: 139000000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_q24_1   = genome.Band{Band: "q24.1", Desc: "Band", StartPos: 139000000, EndPos: 142800000, Giemsa: "gpos75", Chr: &Chr6}
	Chr6_q24_2   = genome.Band{Band: "q24.2", Desc: "Band", StartPos: 142800000, EndPos: 145600000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_q24_3   = genome.Band{Band: "q24.3", Desc: "Band", StartPos: 145600000, EndPos: 149000000, Giemsa: "gpos75", Chr: &Chr6}
	Chr6_q25_1   = genome.Band{Band: "q25.1", Desc: "Band", StartPos: 149000000, EndPos: 152500000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_q25_2   = genome.Band{Band: "q25.2", Desc: "Band", StartPos: 152500000, EndPos: 155500000, Giemsa: "gpos50", Chr: &Chr6}
	Chr6_q25_3   = genome.Band{Band: "q25.3", Desc: "Band", StartPos: 155500000, EndPos: 161000000, Giemsa: "gneg", Chr: &Chr6}
	Chr6_q26     = genome.Band{Band: "q26", Desc: "Band", StartPos: 161000000, EndPos: 164500000, Giemsa: "gpos50", Chr: &Chr6}
	Chr6_q27     = genome.Band{Band: "q27", Desc: "Band", StartPos: 164500000, EndPos: 171115067, Giemsa: "gneg", Chr: &Chr6}
	Chr7_p22_3   = genome.Band{Band: "p22.3", Desc: "Band", StartPos: 0, EndPos: 2800000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_p22_2   = genome.Band{Band: "p22.2", Desc: "Band", StartPos: 2800000, EndPos: 4500000, Giemsa: "gpos25", Chr: &Chr7}
	Chr7_p22_1   = genome.Band{Band: "p22.1", Desc: "Band", StartPos: 4500000, EndPos: 7300000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_p21_3   = genome.Band{Band: "p21.3", Desc: "Band", StartPos: 7300000, EndPos: 13800000, Giemsa: "gpos100", Chr: &Chr7}
	Chr7_p21_2   = genome.Band{Band: "p21.2", Desc: "Band", StartPos: 13800000, EndPos: 16500000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_p21_1   = genome.Band{Band: "p21.1", Desc: "Band", StartPos: 16500000, EndPos: 20900000, Giemsa: "gpos100", Chr: &Chr7}
	Chr7_p15_3   = genome.Band{Band: "p15.3", Desc: "Band", StartPos: 20900000, EndPos: 25500000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_p15_2   = genome.Band{Band: "p15.2", Desc: "Band", StartPos: 25500000, EndPos: 28000000, Giemsa: "gpos50", Chr: &Chr7}
	Chr7_p15_1   = genome.Band{Band: "p15.1", Desc: "Band", StartPos: 28000000, EndPos: 28800000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_p14_3   = genome.Band{Band: "p14.3", Desc: "Band", StartPos: 28800000, EndPos: 35000000, Giemsa: "gpos75", Chr: &Chr7}
	Chr7_p14_2   = genome.Band{Band: "p14.2", Desc: "Band", StartPos: 35000000, EndPos: 37200000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_p14_1   = genome.Band{Band: "p14.1", Desc: "Band", StartPos: 37200000, EndPos: 43300000, Giemsa: "gpos75", Chr: &Chr7}
	Chr7_p13     = genome.Band{Band: "p13", Desc: "Band", StartPos: 43300000, EndPos: 45400000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_p12_3   = genome.Band{Band: "p12.3", Desc: "Band", StartPos: 45400000, EndPos: 49000000, Giemsa: "gpos75", Chr: &Chr7}
	Chr7_p12_2   = genome.Band{Band: "p12.2", Desc: "Band", StartPos: 49000000, EndPos: 50500000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_p12_1   = genome.Band{Band: "p12.1", Desc: "Band", StartPos: 50500000, EndPos: 54000000, Giemsa: "gpos75", Chr: &Chr7}
	Chr7_p11_2   = genome.Band{Band: "p11.2", Desc: "Band", StartPos: 54000000, EndPos: 58000000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_p11_1   = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 58000000, EndPos: 59900000, Giemsa: "acen", Chr: &Chr7}
	Chr7_q11_1   = genome.Band{Band: "q11.1", Desc: "Band", StartPos: 59900000, EndPos: 61700000, Giemsa: "acen", Chr: &Chr7}
	Chr7_q11_21  = genome.Band{Band: "q11.21", Desc: "Band", StartPos: 61700000, EndPos: 67000000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_q11_22  = genome.Band{Band: "q11.22", Desc: "Band", StartPos: 67000000, EndPos: 72200000, Giemsa: "gpos50", Chr: &Chr7}
	Chr7_q11_23  = genome.Band{Band: "q11.23", Desc: "Band", StartPos: 72200000, EndPos: 77500000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_q21_11  = genome.Band{Band: "q21.11", Desc: "Band", StartPos: 77500000, EndPos: 86400000, Giemsa: "gpos100", Chr: &Chr7}
	Chr7_q21_12  = genome.Band{Band: "q21.12", Desc: "Band", StartPos: 86400000, EndPos: 88200000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_q21_13  = genome.Band{Band: "q21.13", Desc: "Band", StartPos: 88200000, EndPos: 91100000, Giemsa: "gpos75", Chr: &Chr7}
	Chr7_q21_2   = genome.Band{Band: "q21.2", Desc: "Band", StartPos: 91100000, EndPos: 92800000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_q21_3   = genome.Band{Band: "q21.3", Desc: "Band", StartPos: 92800000, EndPos: 98000000, Giemsa: "gpos75", Chr: &Chr7}
	Chr7_q22_1   = genome.Band{Band: "q22.1", Desc: "Band", StartPos: 98000000, EndPos: 103800000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_q22_2   = genome.Band{Band: "q22.2", Desc: "Band", StartPos: 103800000, EndPos: 104500000, Giemsa: "gpos50", Chr: &Chr7}
	Chr7_q22_3   = genome.Band{Band: "q22.3", Desc: "Band", StartPos: 104500000, EndPos: 107400000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_q31_1   = genome.Band{Band: "q31.1", Desc: "Band", StartPos: 107400000, EndPos: 114600000, Giemsa: "gpos75", Chr: &Chr7}
	Chr7_q31_2   = genome.Band{Band: "q31.2", Desc: "Band", StartPos: 114600000, EndPos: 117400000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_q31_31  = genome.Band{Band: "q31.31", Desc: "Band", StartPos: 117400000, EndPos: 121100000, Giemsa: "gpos75", Chr: &Chr7}
	Chr7_q31_32  = genome.Band{Band: "q31.32", Desc: "Band", StartPos: 121100000, EndPos: 123800000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_q31_33  = genome.Band{Band: "q31.33", Desc: "Band", StartPos: 123800000, EndPos: 127100000, Giemsa: "gpos75", Chr: &Chr7}
	Chr7_q32_1   = genome.Band{Band: "q32.1", Desc: "Band", StartPos: 127100000, EndPos: 129200000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_q32_2   = genome.Band{Band: "q32.2", Desc: "Band", StartPos: 129200000, EndPos: 130400000, Giemsa: "gpos25", Chr: &Chr7}
	Chr7_q32_3   = genome.Band{Band: "q32.3", Desc: "Band", StartPos: 130400000, EndPos: 132600000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_q33     = genome.Band{Band: "q33", Desc: "Band", StartPos: 132600000, EndPos: 138200000, Giemsa: "gpos50", Chr: &Chr7}
	Chr7_q34     = genome.Band{Band: "q34", Desc: "Band", StartPos: 138200000, EndPos: 143100000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_q35     = genome.Band{Band: "q35", Desc: "Band", StartPos: 143100000, EndPos: 147900000, Giemsa: "gpos75", Chr: &Chr7}
	Chr7_q36_1   = genome.Band{Band: "q36.1", Desc: "Band", StartPos: 147900000, EndPos: 152600000, Giemsa: "gneg", Chr: &Chr7}
	Chr7_q36_2   = genome.Band{Band: "q36.2", Desc: "Band", StartPos: 152600000, EndPos: 155100000, Giemsa: "gpos25", Chr: &Chr7}
	Chr7_q36_3   = genome.Band{Band: "q36.3", Desc: "Band", StartPos: 155100000, EndPos: 159138663, Giemsa: "gneg", Chr: &Chr7}
	Chr8_p23_3   = genome.Band{Band: "p23.3", Desc: "Band", StartPos: 0, EndPos: 2200000, Giemsa: "gneg", Chr: &Chr8}
	Chr8_p23_2   = genome.Band{Band: "p23.2", Desc: "Band", StartPos: 2200000, EndPos: 6200000, Giemsa: "gpos75", Chr: &Chr8}
	Chr8_p23_1   = genome.Band{Band: "p23.1", Desc: "Band", StartPos: 6200000, EndPos: 12700000, Giemsa: "gneg", Chr: &Chr8}
	Chr8_p22     = genome.Band{Band: "p22", Desc: "Band", StartPos: 12700000, EndPos: 19000000, Giemsa: "gpos100", Chr: &Chr8}
	Chr8_p21_3   = genome.Band{Band: "p21.3", Desc: "Band", StartPos: 19000000, EndPos: 23300000, Giemsa: "gneg", Chr: &Chr8}
	Chr8_p21_2   = genome.Band{Band: "p21.2", Desc: "Band", StartPos: 23300000, EndPos: 27400000, Giemsa: "gpos50", Chr: &Chr8}
	Chr8_p21_1   = genome.Band{Band: "p21.1", Desc: "Band", StartPos: 27400000, EndPos: 28800000, Giemsa: "gneg", Chr: &Chr8}
	Chr8_p12     = genome.Band{Band: "p12", Desc: "Band", StartPos: 28800000, EndPos: 36500000, Giemsa: "gpos75", Chr: &Chr8}
	Chr8_p11_23  = genome.Band{Band: "p11.23", Desc: "Band", StartPos: 36500000, EndPos: 38300000, Giemsa: "gneg", Chr: &Chr8}
	Chr8_p11_22  = genome.Band{Band: "p11.22", Desc: "Band", StartPos: 38300000, EndPos: 39700000, Giemsa: "gpos25", Chr: &Chr8}
	Chr8_p11_21  = genome.Band{Band: "p11.21", Desc: "Band", StartPos: 39700000, EndPos: 43100000, Giemsa: "gneg", Chr: &Chr8}
	Chr8_p11_1   = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 43100000, EndPos: 45600000, Giemsa: "acen", Chr: &Chr8}
	Chr8_q11_1   = genome.Band{Band: "q11.1", Desc: "Band", StartPos: 45600000, EndPos: 48100000, Giemsa: "acen", Chr: &Chr8}
	Chr8_q11_21  = genome.Band{Band: "q11.21", Desc: "Band", StartPos: 48100000, EndPos: 52200000, Giemsa: "gneg", Chr: &Chr8}
	Chr8_q11_22  = genome.Band{Band: "q11.22", Desc: "Band", StartPos: 52200000, EndPos: 52600000, Giemsa: "gpos75", Chr: &Chr8}
	Chr8_q11_23  = genome.Band{Band: "q11.23", Desc: "Band", StartPos: 52600000, EndPos: 55500000, Giemsa: "gneg", Chr: &Chr8}
	Chr8_q12_1   = genome.Band{Band: "q12.1", Desc: "Band", StartPos: 55500000, EndPos: 61600000, Giemsa: "gpos50", Chr: &Chr8}
	Chr8_q12_2   = genome.Band{Band: "q12.2", Desc: "Band", StartPos: 61600000, EndPos: 62200000, Giemsa: "gneg", Chr: &Chr8}
	Chr8_q12_3   = genome.Band{Band: "q12.3", Desc: "Band", StartPos: 62200000, EndPos: 66000000, Giemsa: "gpos50", Chr: &Chr8}
	Chr8_q13_1   = genome.Band{Band: "q13.1", Desc: "Band", StartPos: 66000000, EndPos: 68000000, Giemsa: "gneg", Chr: &Chr8}
	Chr8_q13_2   = genome.Band{Band: "q13.2", Desc: "Band", StartPos: 68000000, EndPos: 70500000, Giemsa: "gpos50", Chr: &Chr8}
	Chr8_q13_3   = genome.Band{Band: "q13.3", Desc: "Band", StartPos: 70500000, EndPos: 73900000, Giemsa: "gneg", Chr: &Chr8}
	Chr8_q21_11  = genome.Band{Band: "q21.11", Desc: "Band", StartPos: 73900000, EndPos: 78300000, Giemsa: "gpos100", Chr: &Chr8}
	Chr8_q21_12  = genome.Band{Band: "q21.12", Desc: "Band", StartPos: 78300000, EndPos: 80100000, Giemsa: "gneg", Chr: &Chr8}
	Chr8_q21_13  = genome.Band{Band: "q21.13", Desc: "Band", StartPos: 80100000, EndPos: 84600000, Giemsa: "gpos75", Chr: &Chr8}
	Chr8_q21_2   = genome.Band{Band: "q21.2", Desc: "Band", StartPos: 84600000, EndPos: 86900000, Giemsa: "gneg", Chr: &Chr8}
	Chr8_q21_3   = genome.Band{Band: "q21.3", Desc: "Band", StartPos: 86900000, EndPos: 93300000, Giemsa: "gpos100", Chr: &Chr8}
	Chr8_q22_1   = genome.Band{Band: "q22.1", Desc: "Band", StartPos: 93300000, EndPos: 99000000, Giemsa: "gneg", Chr: &Chr8}
	Chr8_q22_2   = genome.Band{Band: "q22.2", Desc: "Band", StartPos: 99000000, EndPos: 101600000, Giemsa: "gpos25", Chr: &Chr8}
	Chr8_q22_3   = genome.Band{Band: "q22.3", Desc: "Band", StartPos: 101600000, EndPos: 106200000, Giemsa: "gneg", Chr: &Chr8}
	Chr8_q23_1   = genome.Band{Band: "q23.1", Desc: "Band", StartPos: 106200000, EndPos: 110500000, Giemsa: "gpos75", Chr: &Chr8}
	Chr8_q23_2   = genome.Band{Band: "q23.2", Desc: "Band", StartPos: 110500000, EndPos: 112100000, Giemsa: "gneg", Chr: &Chr8}
	Chr8_q23_3   = genome.Band{Band: "q23.3", Desc: "Band", StartPos: 112100000, EndPos: 117700000, Giemsa: "gpos100", Chr: &Chr8}
	Chr8_q24_11  = genome.Band{Band: "q24.11", Desc: "Band", StartPos: 117700000, EndPos: 119200000, Giemsa: "gneg", Chr: &Chr8}
	Chr8_q24_12  = genome.Band{Band: "q24.12", Desc: "Band", StartPos: 119200000, EndPos: 122500000, Giemsa: "gpos50", Chr: &Chr8}
	Chr8_q24_13  = genome.Band{Band: "q24.13", Desc: "Band", StartPos: 122500000, EndPos: 127300000, Giemsa: "gneg", Chr: &Chr8}
	Chr8_q24_21  = genome.Band{Band: "q24.21", Desc: "Band", StartPos: 127300000, EndPos: 131500000, Giemsa: "gpos50", Chr: &Chr8}
	Chr8_q24_22  = genome.Band{Band: "q24.22", Desc: "Band", StartPos: 131500000, EndPos: 136400000, Giemsa: "gneg", Chr: &Chr8}
	Chr8_q24_23  = genome.Band{Band: "q24.23", Desc: "Band", StartPos: 136400000, EndPos: 139900000, Giemsa: "gpos75", Chr: &Chr8}
	Chr8_q24_3   = genome.Band{Band: "q24.3", Desc: "Band", StartPos: 139900000, EndPos: 146364022, Giemsa: "gneg", Chr: &Chr8}
	Chr9_p24_3   = genome.Band{Band: "p24.3", Desc: "Band", StartPos: 0, EndPos: 2200000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_p24_2   = genome.Band{Band: "p24.2", Desc: "Band", StartPos: 2200000, EndPos: 4600000, Giemsa: "gpos25", Chr: &Chr9}
	Chr9_p24_1   = genome.Band{Band: "p24.1", Desc: "Band", StartPos: 4600000, EndPos: 9000000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_p23     = genome.Band{Band: "p23", Desc: "Band", StartPos: 9000000, EndPos: 14200000, Giemsa: "gpos75", Chr: &Chr9}
	Chr9_p22_3   = genome.Band{Band: "p22.3", Desc: "Band", StartPos: 14200000, EndPos: 16600000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_p22_2   = genome.Band{Band: "p22.2", Desc: "Band", StartPos: 16600000, EndPos: 18500000, Giemsa: "gpos25", Chr: &Chr9}
	Chr9_p22_1   = genome.Band{Band: "p22.1", Desc: "Band", StartPos: 18500000, EndPos: 19900000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_p21_3   = genome.Band{Band: "p21.3", Desc: "Band", StartPos: 19900000, EndPos: 25600000, Giemsa: "gpos100", Chr: &Chr9}
	Chr9_p21_2   = genome.Band{Band: "p21.2", Desc: "Band", StartPos: 25600000, EndPos: 28000000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_p21_1   = genome.Band{Band: "p21.1", Desc: "Band", StartPos: 28000000, EndPos: 33200000, Giemsa: "gpos100", Chr: &Chr9}
	Chr9_p13_3   = genome.Band{Band: "p13.3", Desc: "Band", StartPos: 33200000, EndPos: 36300000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_p13_2   = genome.Band{Band: "p13.2", Desc: "Band", StartPos: 36300000, EndPos: 38400000, Giemsa: "gpos25", Chr: &Chr9}
	Chr9_p13_1   = genome.Band{Band: "p13.1", Desc: "Band", StartPos: 38400000, EndPos: 41000000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_p12     = genome.Band{Band: "p12", Desc: "Band", StartPos: 41000000, EndPos: 43600000, Giemsa: "gpos50", Chr: &Chr9}
	Chr9_p11_2   = genome.Band{Band: "p11.2", Desc: "Band", StartPos: 43600000, EndPos: 47300000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_p11_1   = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 47300000, EndPos: 49000000, Giemsa: "acen", Chr: &Chr9}
	Chr9_q11     = genome.Band{Band: "q11", Desc: "Band", StartPos: 49000000, EndPos: 50700000, Giemsa: "acen", Chr: &Chr9}
	Chr9_q12     = genome.Band{Band: "q12", Desc: "Band", StartPos: 50700000, EndPos: 65900000, Giemsa: "gvar", Chr: &Chr9}
	Chr9_q13     = genome.Band{Band: "q13", Desc: "Band", StartPos: 65900000, EndPos: 68700000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_q21_11  = genome.Band{Band: "q21.11", Desc: "Band", StartPos: 68700000, EndPos: 72200000, Giemsa: "gpos25", Chr: &Chr9}
	Chr9_q21_12  = genome.Band{Band: "q21.12", Desc: "Band", StartPos: 72200000, EndPos: 74000000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_q21_13  = genome.Band{Band: "q21.13", Desc: "Band", StartPos: 74000000, EndPos: 79200000, Giemsa: "gpos50", Chr: &Chr9}
	Chr9_q21_2   = genome.Band{Band: "q21.2", Desc: "Band", StartPos: 79200000, EndPos: 81100000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_q21_31  = genome.Band{Band: "q21.31", Desc: "Band", StartPos: 81100000, EndPos: 84100000, Giemsa: "gpos50", Chr: &Chr9}
	Chr9_q21_32  = genome.Band{Band: "q21.32", Desc: "Band", StartPos: 84100000, EndPos: 86900000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_q21_33  = genome.Band{Band: "q21.33", Desc: "Band", StartPos: 86900000, EndPos: 90400000, Giemsa: "gpos50", Chr: &Chr9}
	Chr9_q22_1   = genome.Band{Band: "q22.1", Desc: "Band", StartPos: 90400000, EndPos: 91800000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_q22_2   = genome.Band{Band: "q22.2", Desc: "Band", StartPos: 91800000, EndPos: 93900000, Giemsa: "gpos25", Chr: &Chr9}
	Chr9_q22_31  = genome.Band{Band: "q22.31", Desc: "Band", StartPos: 93900000, EndPos: 96600000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_q22_32  = genome.Band{Band: "q22.32", Desc: "Band", StartPos: 96600000, EndPos: 99300000, Giemsa: "gpos25", Chr: &Chr9}
	Chr9_q22_33  = genome.Band{Band: "q22.33", Desc: "Band", StartPos: 99300000, EndPos: 102600000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_q31_1   = genome.Band{Band: "q31.1", Desc: "Band", StartPos: 102600000, EndPos: 108200000, Giemsa: "gpos100", Chr: &Chr9}
	Chr9_q31_2   = genome.Band{Band: "q31.2", Desc: "Band", StartPos: 108200000, EndPos: 111300000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_q31_3   = genome.Band{Band: "q31.3", Desc: "Band", StartPos: 111300000, EndPos: 114900000, Giemsa: "gpos25", Chr: &Chr9}
	Chr9_q32     = genome.Band{Band: "q32", Desc: "Band", StartPos: 114900000, EndPos: 117700000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_q33_1   = genome.Band{Band: "q33.1", Desc: "Band", StartPos: 117700000, EndPos: 122500000, Giemsa: "gpos75", Chr: &Chr9}
	Chr9_q33_2   = genome.Band{Band: "q33.2", Desc: "Band", StartPos: 122500000, EndPos: 125800000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_q33_3   = genome.Band{Band: "q33.3", Desc: "Band", StartPos: 125800000, EndPos: 130300000, Giemsa: "gpos25", Chr: &Chr9}
	Chr9_q34_11  = genome.Band{Band: "q34.11", Desc: "Band", StartPos: 130300000, EndPos: 133500000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_q34_12  = genome.Band{Band: "q34.12", Desc: "Band", StartPos: 133500000, EndPos: 134000000, Giemsa: "gpos25", Chr: &Chr9}
	Chr9_q34_13  = genome.Band{Band: "q34.13", Desc: "Band", StartPos: 134000000, EndPos: 135900000, Giemsa: "gneg", Chr: &Chr9}
	Chr9_q34_2   = genome.Band{Band: "q34.2", Desc: "Band", StartPos: 135900000, EndPos: 137400000, Giemsa: "gpos25", Chr: &Chr9}
	Chr9_q34_3   = genome.Band{Band: "q34.3", Desc: "Band", StartPos: 137400000, EndPos: 141213431, Giemsa: "gneg", Chr: &Chr9}
	Chr10_p15_3  = genome.Band{Band: "p15.3", Desc: "Band", StartPos: 0, EndPos: 3000000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_p15_2  = genome.Band{Band: "p15.2", Desc: "Band", StartPos: 3000000, EndPos: 3800000, Giemsa: "gpos25", Chr: &Chr10}
	Chr10_p15_1  = genome.Band{Band: "p15.1", Desc: "Band", StartPos: 3800000, EndPos: 6600000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_p14    = genome.Band{Band: "p14", Desc: "Band", StartPos: 6600000, EndPos: 12200000, Giemsa: "gpos75", Chr: &Chr10}
	Chr10_p13    = genome.Band{Band: "p13", Desc: "Band", StartPos: 12200000, EndPos: 17300000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_p12_33 = genome.Band{Band: "p12.33", Desc: "Band", StartPos: 17300000, EndPos: 18600000, Giemsa: "gpos75", Chr: &Chr10}
	Chr10_p12_32 = genome.Band{Band: "p12.32", Desc: "Band", StartPos: 18600000, EndPos: 18700000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_p12_31 = genome.Band{Band: "p12.31", Desc: "Band", StartPos: 18700000, EndPos: 22600000, Giemsa: "gpos75", Chr: &Chr10}
	Chr10_p12_2  = genome.Band{Band: "p12.2", Desc: "Band", StartPos: 22600000, EndPos: 24600000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_p12_1  = genome.Band{Band: "p12.1", Desc: "Band", StartPos: 24600000, EndPos: 29600000, Giemsa: "gpos50", Chr: &Chr10}
	Chr10_p11_23 = genome.Band{Band: "p11.23", Desc: "Band", StartPos: 29600000, EndPos: 31300000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_p11_22 = genome.Band{Band: "p11.22", Desc: "Band", StartPos: 31300000, EndPos: 34400000, Giemsa: "gpos25", Chr: &Chr10}
	Chr10_p11_21 = genome.Band{Band: "p11.21", Desc: "Band", StartPos: 34400000, EndPos: 38000000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_p11_1  = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 38000000, EndPos: 40200000, Giemsa: "acen", Chr: &Chr10}
	Chr10_q11_1  = genome.Band{Band: "q11.1", Desc: "Band", StartPos: 40200000, EndPos: 42300000, Giemsa: "acen", Chr: &Chr10}
	Chr10_q11_21 = genome.Band{Band: "q11.21", Desc: "Band", StartPos: 42300000, EndPos: 46100000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_q11_22 = genome.Band{Band: "q11.22", Desc: "Band", StartPos: 46100000, EndPos: 49900000, Giemsa: "gpos25", Chr: &Chr10}
	Chr10_q11_23 = genome.Band{Band: "q11.23", Desc: "Band", StartPos: 49900000, EndPos: 52900000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_q21_1  = genome.Band{Band: "q21.1", Desc: "Band", StartPos: 52900000, EndPos: 61200000, Giemsa: "gpos100", Chr: &Chr10}
	Chr10_q21_2  = genome.Band{Band: "q21.2", Desc: "Band", StartPos: 61200000, EndPos: 64500000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_q21_3  = genome.Band{Band: "q21.3", Desc: "Band", StartPos: 64500000, EndPos: 70600000, Giemsa: "gpos100", Chr: &Chr10}
	Chr10_q22_1  = genome.Band{Band: "q22.1", Desc: "Band", StartPos: 70600000, EndPos: 74900000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_q22_2  = genome.Band{Band: "q22.2", Desc: "Band", StartPos: 74900000, EndPos: 77700000, Giemsa: "gpos50", Chr: &Chr10}
	Chr10_q22_3  = genome.Band{Band: "q22.3", Desc: "Band", StartPos: 77700000, EndPos: 82000000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_q23_1  = genome.Band{Band: "q23.1", Desc: "Band", StartPos: 82000000, EndPos: 87900000, Giemsa: "gpos100", Chr: &Chr10}
	Chr10_q23_2  = genome.Band{Band: "q23.2", Desc: "Band", StartPos: 87900000, EndPos: 89500000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_q23_31 = genome.Band{Band: "q23.31", Desc: "Band", StartPos: 89500000, EndPos: 92900000, Giemsa: "gpos75", Chr: &Chr10}
	Chr10_q23_32 = genome.Band{Band: "q23.32", Desc: "Band", StartPos: 92900000, EndPos: 94100000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_q23_33 = genome.Band{Band: "q23.33", Desc: "Band", StartPos: 94100000, EndPos: 97000000, Giemsa: "gpos50", Chr: &Chr10}
	Chr10_q24_1  = genome.Band{Band: "q24.1", Desc: "Band", StartPos: 97000000, EndPos: 99300000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_q24_2  = genome.Band{Band: "q24.2", Desc: "Band", StartPos: 99300000, EndPos: 101900000, Giemsa: "gpos50", Chr: &Chr10}
	Chr10_q24_31 = genome.Band{Band: "q24.31", Desc: "Band", StartPos: 101900000, EndPos: 103000000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_q24_32 = genome.Band{Band: "q24.32", Desc: "Band", StartPos: 103000000, EndPos: 104900000, Giemsa: "gpos25", Chr: &Chr10}
	Chr10_q24_33 = genome.Band{Band: "q24.33", Desc: "Band", StartPos: 104900000, EndPos: 105800000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_q25_1  = genome.Band{Band: "q25.1", Desc: "Band", StartPos: 105800000, EndPos: 111900000, Giemsa: "gpos100", Chr: &Chr10}
	Chr10_q25_2  = genome.Band{Band: "q25.2", Desc: "Band", StartPos: 111900000, EndPos: 114900000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_q25_3  = genome.Band{Band: "q25.3", Desc: "Band", StartPos: 114900000, EndPos: 119100000, Giemsa: "gpos75", Chr: &Chr10}
	Chr10_q26_11 = genome.Band{Band: "q26.11", Desc: "Band", StartPos: 119100000, EndPos: 121700000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_q26_12 = genome.Band{Band: "q26.12", Desc: "Band", StartPos: 121700000, EndPos: 123100000, Giemsa: "gpos50", Chr: &Chr10}
	Chr10_q26_13 = genome.Band{Band: "q26.13", Desc: "Band", StartPos: 123100000, EndPos: 127500000, Giemsa: "gneg", Chr: &Chr10}
	Chr10_q26_2  = genome.Band{Band: "q26.2", Desc: "Band", StartPos: 127500000, EndPos: 130600000, Giemsa: "gpos50", Chr: &Chr10}
	Chr10_q26_3  = genome.Band{Band: "q26.3", Desc: "Band", StartPos: 130600000, EndPos: 135534747, Giemsa: "gneg", Chr: &Chr10}
	Chr11_p15_5  = genome.Band{Band: "p15.5", Desc: "Band", StartPos: 0, EndPos: 2800000, Giemsa: "gneg", Chr: &Chr11}
	Chr11_p15_4  = genome.Band{Band: "p15.4", Desc: "Band", StartPos: 2800000, EndPos: 10700000, Giemsa: "gpos50", Chr: &Chr11}
	Chr11_p15_3  = genome.Band{Band: "p15.3", Desc: "Band", StartPos: 10700000, EndPos: 12700000, Giemsa: "gneg", Chr: &Chr11}
	Chr11_p15_2  = genome.Band{Band: "p15.2", Desc: "Band", StartPos: 12700000, EndPos: 16200000, Giemsa: "gpos50", Chr: &Chr11}
	Chr11_p15_1  = genome.Band{Band: "p15.1", Desc: "Band", StartPos: 16200000, EndPos: 21700000, Giemsa: "gneg", Chr: &Chr11}
	Chr11_p14_3  = genome.Band{Band: "p14.3", Desc: "Band", StartPos: 21700000, EndPos: 26100000, Giemsa: "gpos100", Chr: &Chr11}
	Chr11_p14_2  = genome.Band{Band: "p14.2", Desc: "Band", StartPos: 26100000, EndPos: 27200000, Giemsa: "gneg", Chr: &Chr11}
	Chr11_p14_1  = genome.Band{Band: "p14.1", Desc: "Band", StartPos: 27200000, EndPos: 31000000, Giemsa: "gpos75", Chr: &Chr11}
	Chr11_p13    = genome.Band{Band: "p13", Desc: "Band", StartPos: 31000000, EndPos: 36400000, Giemsa: "gneg", Chr: &Chr11}
	Chr11_p12    = genome.Band{Band: "p12", Desc: "Band", StartPos: 36400000, EndPos: 43500000, Giemsa: "gpos100", Chr: &Chr11}
	Chr11_p11_2  = genome.Band{Band: "p11.2", Desc: "Band", StartPos: 43500000, EndPos: 48800000, Giemsa: "gneg", Chr: &Chr11}
	Chr11_p11_12 = genome.Band{Band: "p11.12", Desc: "Band", StartPos: 48800000, EndPos: 51600000, Giemsa: "gpos75", Chr: &Chr11}
	Chr11_p11_11 = genome.Band{Band: "p11.11", Desc: "Band", StartPos: 51600000, EndPos: 53700000, Giemsa: "acen", Chr: &Chr11}
	Chr11_q11    = genome.Band{Band: "q11", Desc: "Band", StartPos: 53700000, EndPos: 55700000, Giemsa: "acen", Chr: &Chr11}
	Chr11_q12_1  = genome.Band{Band: "q12.1", Desc: "Band", StartPos: 55700000, EndPos: 59900000, Giemsa: "gpos75", Chr: &Chr11}
	Chr11_q12_2  = genome.Band{Band: "q12.2", Desc: "Band", StartPos: 59900000, EndPos: 61700000, Giemsa: "gneg", Chr: &Chr11}
	Chr11_q12_3  = genome.Band{Band: "q12.3", Desc: "Band", StartPos: 61700000, EndPos: 63400000, Giemsa: "gpos25", Chr: &Chr11}
	Chr11_q13_1  = genome.Band{Band: "q13.1", Desc: "Band", StartPos: 63400000, EndPos: 65900000, Giemsa: "gneg", Chr: &Chr11}
	Chr11_q13_2  = genome.Band{Band: "q13.2", Desc: "Band", StartPos: 65900000, EndPos: 68400000, Giemsa: "gpos25", Chr: &Chr11}
	Chr11_q13_3  = genome.Band{Band: "q13.3", Desc: "Band", StartPos: 68400000, EndPos: 70400000, Giemsa: "gneg", Chr: &Chr11}
	Chr11_q13_4  = genome.Band{Band: "q13.4", Desc: "Band", StartPos: 70400000, EndPos: 75200000, Giemsa: "gpos50", Chr: &Chr11}
	Chr11_q13_5  = genome.Band{Band: "q13.5", Desc: "Band", StartPos: 75200000, EndPos: 77100000, Giemsa: "gneg", Chr: &Chr11}
	Chr11_q14_1  = genome.Band{Band: "q14.1", Desc: "Band", StartPos: 77100000, EndPos: 85600000, Giemsa: "gpos100", Chr: &Chr11}
	Chr11_q14_2  = genome.Band{Band: "q14.2", Desc: "Band", StartPos: 85600000, EndPos: 88300000, Giemsa: "gneg", Chr: &Chr11}
	Chr11_q14_3  = genome.Band{Band: "q14.3", Desc: "Band", StartPos: 88300000, EndPos: 92800000, Giemsa: "gpos100", Chr: &Chr11}
	Chr11_q21    = genome.Band{Band: "q21", Desc: "Band", StartPos: 92800000, EndPos: 97200000, Giemsa: "gneg", Chr: &Chr11}
	Chr11_q22_1  = genome.Band{Band: "q22.1", Desc: "Band", StartPos: 97200000, EndPos: 102100000, Giemsa: "gpos100", Chr: &Chr11}
	Chr11_q22_2  = genome.Band{Band: "q22.2", Desc: "Band", StartPos: 102100000, EndPos: 102900000, Giemsa: "gneg", Chr: &Chr11}
	Chr11_q22_3  = genome.Band{Band: "q22.3", Desc: "Band", StartPos: 102900000, EndPos: 110400000, Giemsa: "gpos100", Chr: &Chr11}
	Chr11_q23_1  = genome.Band{Band: "q23.1", Desc: "Band", StartPos: 110400000, EndPos: 112500000, Giemsa: "gneg", Chr: &Chr11}
	Chr11_q23_2  = genome.Band{Band: "q23.2", Desc: "Band", StartPos: 112500000, EndPos: 114500000, Giemsa: "gpos50", Chr: &Chr11}
	Chr11_q23_3  = genome.Band{Band: "q23.3", Desc: "Band", StartPos: 114500000, EndPos: 121200000, Giemsa: "gneg", Chr: &Chr11}
	Chr11_q24_1  = genome.Band{Band: "q24.1", Desc: "Band", StartPos: 121200000, EndPos: 123900000, Giemsa: "gpos50", Chr: &Chr11}
	Chr11_q24_2  = genome.Band{Band: "q24.2", Desc: "Band", StartPos: 123900000, EndPos: 127800000, Giemsa: "gneg", Chr: &Chr11}
	Chr11_q24_3  = genome.Band{Band: "q24.3", Desc: "Band", StartPos: 127800000, EndPos: 130800000, Giemsa: "gpos50", Chr: &Chr11}
	Chr11_q25    = genome.Band{Band: "q25", Desc: "Band", StartPos: 130800000, EndPos: 135006516, Giemsa: "gneg", Chr: &Chr11}
	Chr12_p13_33 = genome.Band{Band: "p13.33", Desc: "Band", StartPos: 0, EndPos: 3300000, Giemsa: "gneg", Chr: &Chr12}
	Chr12_p13_32 = genome.Band{Band: "p13.32", Desc: "Band", StartPos: 3300000, EndPos: 5400000, Giemsa: "gpos25", Chr: &Chr12}
	Chr12_p13_31 = genome.Band{Band: "p13.31", Desc: "Band", StartPos: 5400000, EndPos: 10100000, Giemsa: "gneg", Chr: &Chr12}
	Chr12_p13_2  = genome.Band{Band: "p13.2", Desc: "Band", StartPos: 10100000, EndPos: 12800000, Giemsa: "gpos75", Chr: &Chr12}
	Chr12_p13_1  = genome.Band{Band: "p13.1", Desc: "Band", StartPos: 12800000, EndPos: 14800000, Giemsa: "gneg", Chr: &Chr12}
	Chr12_p12_3  = genome.Band{Band: "p12.3", Desc: "Band", StartPos: 14800000, EndPos: 20000000, Giemsa: "gpos100", Chr: &Chr12}
	Chr12_p12_2  = genome.Band{Band: "p12.2", Desc: "Band", StartPos: 20000000, EndPos: 21300000, Giemsa: "gneg", Chr: &Chr12}
	Chr12_p12_1  = genome.Band{Band: "p12.1", Desc: "Band", StartPos: 21300000, EndPos: 26500000, Giemsa: "gpos100", Chr: &Chr12}
	Chr12_p11_23 = genome.Band{Band: "p11.23", Desc: "Band", StartPos: 26500000, EndPos: 27800000, Giemsa: "gneg", Chr: &Chr12}
	Chr12_p11_22 = genome.Band{Band: "p11.22", Desc: "Band", StartPos: 27800000, EndPos: 30700000, Giemsa: "gpos50", Chr: &Chr12}
	Chr12_p11_21 = genome.Band{Band: "p11.21", Desc: "Band", StartPos: 30700000, EndPos: 33300000, Giemsa: "gneg", Chr: &Chr12}
	Chr12_p11_1  = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 33300000, EndPos: 35800000, Giemsa: "acen", Chr: &Chr12}
	Chr12_q11    = genome.Band{Band: "q11", Desc: "Band", StartPos: 35800000, EndPos: 38200000, Giemsa: "acen", Chr: &Chr12}
	Chr12_q12    = genome.Band{Band: "q12", Desc: "Band", StartPos: 38200000, EndPos: 46400000, Giemsa: "gpos100", Chr: &Chr12}
	Chr12_q13_11 = genome.Band{Band: "q13.11", Desc: "Band", StartPos: 46400000, EndPos: 49100000, Giemsa: "gneg", Chr: &Chr12}
	Chr12_q13_12 = genome.Band{Band: "q13.12", Desc: "Band", StartPos: 49100000, EndPos: 51500000, Giemsa: "gpos25", Chr: &Chr12}
	Chr12_q13_13 = genome.Band{Band: "q13.13", Desc: "Band", StartPos: 51500000, EndPos: 54900000, Giemsa: "gneg", Chr: &Chr12}
	Chr12_q13_2  = genome.Band{Band: "q13.2", Desc: "Band", StartPos: 54900000, EndPos: 56600000, Giemsa: "gpos25", Chr: &Chr12}
	Chr12_q13_3  = genome.Band{Band: "q13.3", Desc: "Band", StartPos: 56600000, EndPos: 58100000, Giemsa: "gneg", Chr: &Chr12}
	Chr12_q14_1  = genome.Band{Band: "q14.1", Desc: "Band", StartPos: 58100000, EndPos: 63100000, Giemsa: "gpos75", Chr: &Chr12}
	Chr12_q14_2  = genome.Band{Band: "q14.2", Desc: "Band", StartPos: 63100000, EndPos: 65100000, Giemsa: "gneg", Chr: &Chr12}
	Chr12_q14_3  = genome.Band{Band: "q14.3", Desc: "Band", StartPos: 65100000, EndPos: 67700000, Giemsa: "gpos50", Chr: &Chr12}
	Chr12_q15    = genome.Band{Band: "q15", Desc: "Band", StartPos: 67700000, EndPos: 71500000, Giemsa: "gneg", Chr: &Chr12}
	Chr12_q21_1  = genome.Band{Band: "q21.1", Desc: "Band", StartPos: 71500000, EndPos: 75700000, Giemsa: "gpos75", Chr: &Chr12}
	Chr12_q21_2  = genome.Band{Band: "q21.2", Desc: "Band", StartPos: 75700000, EndPos: 80300000, Giemsa: "gneg", Chr: &Chr12}
	Chr12_q21_31 = genome.Band{Band: "q21.31", Desc: "Band", StartPos: 80300000, EndPos: 86700000, Giemsa: "gpos100", Chr: &Chr12}
	Chr12_q21_32 = genome.Band{Band: "q21.32", Desc: "Band", StartPos: 86700000, EndPos: 89000000, Giemsa: "gneg", Chr: &Chr12}
	Chr12_q21_33 = genome.Band{Band: "q21.33", Desc: "Band", StartPos: 89000000, EndPos: 92600000, Giemsa: "gpos100", Chr: &Chr12}
	Chr12_q22    = genome.Band{Band: "q22", Desc: "Band", StartPos: 92600000, EndPos: 96200000, Giemsa: "gneg", Chr: &Chr12}
	Chr12_q23_1  = genome.Band{Band: "q23.1", Desc: "Band", StartPos: 96200000, EndPos: 101600000, Giemsa: "gpos75", Chr: &Chr12}
	Chr12_q23_2  = genome.Band{Band: "q23.2", Desc: "Band", StartPos: 101600000, EndPos: 103800000, Giemsa: "gneg", Chr: &Chr12}
	Chr12_q23_3  = genome.Band{Band: "q23.3", Desc: "Band", StartPos: 103800000, EndPos: 109000000, Giemsa: "gpos50", Chr: &Chr12}
	Chr12_q24_11 = genome.Band{Band: "q24.11", Desc: "Band", StartPos: 109000000, EndPos: 111700000, Giemsa: "gneg", Chr: &Chr12}
	Chr12_q24_12 = genome.Band{Band: "q24.12", Desc: "Band", StartPos: 111700000, EndPos: 112300000, Giemsa: "gpos25", Chr: &Chr12}
	Chr12_q24_13 = genome.Band{Band: "q24.13", Desc: "Band", StartPos: 112300000, EndPos: 114300000, Giemsa: "gneg", Chr: &Chr12}
	Chr12_q24_21 = genome.Band{Band: "q24.21", Desc: "Band", StartPos: 114300000, EndPos: 116800000, Giemsa: "gpos50", Chr: &Chr12}
	Chr12_q24_22 = genome.Band{Band: "q24.22", Desc: "Band", StartPos: 116800000, EndPos: 118100000, Giemsa: "gneg", Chr: &Chr12}
	Chr12_q24_23 = genome.Band{Band: "q24.23", Desc: "Band", StartPos: 118100000, EndPos: 120700000, Giemsa: "gpos50", Chr: &Chr12}
	Chr12_q24_31 = genome.Band{Band: "q24.31", Desc: "Band", StartPos: 120700000, EndPos: 125900000, Giemsa: "gneg", Chr: &Chr12}
	Chr12_q24_32 = genome.Band{Band: "q24.32", Desc: "Band", StartPos: 125900000, EndPos: 129300000, Giemsa: "gpos50", Chr: &Chr12}
	Chr12_q24_33 = genome.Band{Band: "q24.33", Desc: "Band", StartPos: 129300000, EndPos: 133851895, Giemsa: "gneg", Chr: &Chr12}
	Chr13_p13    = genome.Band{Band: "p13", Desc: "Band", StartPos: 0, EndPos: 4500000, Giemsa: "gvar", Chr: &Chr13}
	Chr13_p12    = genome.Band{Band: "p12", Desc: "Band", StartPos: 4500000, EndPos: 10000000, Giemsa: "stalk", Chr: &Chr13}
	Chr13_p11_2  = genome.Band{Band: "p11.2", Desc: "Band", StartPos: 10000000, EndPos: 16300000, Giemsa: "gvar", Chr: &Chr13}
	Chr13_p11_1  = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 16300000, EndPos: 17900000, Giemsa: "acen", Chr: &Chr13}
	Chr13_q11    = genome.Band{Band: "q11", Desc: "Band", StartPos: 17900000, EndPos: 19500000, Giemsa: "acen", Chr: &Chr13}
	Chr13_q12_11 = genome.Band{Band: "q12.11", Desc: "Band", StartPos: 19500000, EndPos: 23300000, Giemsa: "gneg", Chr: &Chr13}
	Chr13_q12_12 = genome.Band{Band: "q12.12", Desc: "Band", StartPos: 23300000, EndPos: 25500000, Giemsa: "gpos25", Chr: &Chr13}
	Chr13_q12_13 = genome.Band{Band: "q12.13", Desc: "Band", StartPos: 25500000, EndPos: 27800000, Giemsa: "gneg", Chr: &Chr13}
	Chr13_q12_2  = genome.Band{Band: "q12.2", Desc: "Band", StartPos: 27800000, EndPos: 28900000, Giemsa: "gpos25", Chr: &Chr13}
	Chr13_q12_3  = genome.Band{Band: "q12.3", Desc: "Band", StartPos: 28900000, EndPos: 32200000, Giemsa: "gneg", Chr: &Chr13}
	Chr13_q13_1  = genome.Band{Band: "q13.1", Desc: "Band", StartPos: 32200000, EndPos: 34000000, Giemsa: "gpos50", Chr: &Chr13}
	Chr13_q13_2  = genome.Band{Band: "q13.2", Desc: "Band", StartPos: 34000000, EndPos: 35500000, Giemsa: "gneg", Chr: &Chr13}
	Chr13_q13_3  = genome.Band{Band: "q13.3", Desc: "Band", StartPos: 35500000, EndPos: 40100000, Giemsa: "gpos75", Chr: &Chr13}
	Chr13_q14_11 = genome.Band{Band: "q14.11", Desc: "Band", StartPos: 40100000, EndPos: 45200000, Giemsa: "gneg", Chr: &Chr13}
	Chr13_q14_12 = genome.Band{Band: "q14.12", Desc: "Band", StartPos: 45200000, EndPos: 45800000, Giemsa: "gpos25", Chr: &Chr13}
	Chr13_q14_13 = genome.Band{Band: "q14.13", Desc: "Band", StartPos: 45800000, EndPos: 47300000, Giemsa: "gneg", Chr: &Chr13}
	Chr13_q14_2  = genome.Band{Band: "q14.2", Desc: "Band", StartPos: 47300000, EndPos: 50900000, Giemsa: "gpos50", Chr: &Chr13}
	Chr13_q14_3  = genome.Band{Band: "q14.3", Desc: "Band", StartPos: 50900000, EndPos: 55300000, Giemsa: "gneg", Chr: &Chr13}
	Chr13_q21_1  = genome.Band{Band: "q21.1", Desc: "Band", StartPos: 55300000, EndPos: 59600000, Giemsa: "gpos100", Chr: &Chr13}
	Chr13_q21_2  = genome.Band{Band: "q21.2", Desc: "Band", StartPos: 59600000, EndPos: 62300000, Giemsa: "gneg", Chr: &Chr13}
	Chr13_q21_31 = genome.Band{Band: "q21.31", Desc: "Band", StartPos: 62300000, EndPos: 65700000, Giemsa: "gpos75", Chr: &Chr13}
	Chr13_q21_32 = genome.Band{Band: "q21.32", Desc: "Band", StartPos: 65700000, EndPos: 68600000, Giemsa: "gneg", Chr: &Chr13}
	Chr13_q21_33 = genome.Band{Band: "q21.33", Desc: "Band", StartPos: 68600000, EndPos: 73300000, Giemsa: "gpos100", Chr: &Chr13}
	Chr13_q22_1  = genome.Band{Band: "q22.1", Desc: "Band", StartPos: 73300000, EndPos: 75400000, Giemsa: "gneg", Chr: &Chr13}
	Chr13_q22_2  = genome.Band{Band: "q22.2", Desc: "Band", StartPos: 75400000, EndPos: 77200000, Giemsa: "gpos50", Chr: &Chr13}
	Chr13_q22_3  = genome.Band{Band: "q22.3", Desc: "Band", StartPos: 77200000, EndPos: 79000000, Giemsa: "gneg", Chr: &Chr13}
	Chr13_q31_1  = genome.Band{Band: "q31.1", Desc: "Band", StartPos: 79000000, EndPos: 87700000, Giemsa: "gpos100", Chr: &Chr13}
	Chr13_q31_2  = genome.Band{Band: "q31.2", Desc: "Band", StartPos: 87700000, EndPos: 90000000, Giemsa: "gneg", Chr: &Chr13}
	Chr13_q31_3  = genome.Band{Band: "q31.3", Desc: "Band", StartPos: 90000000, EndPos: 95000000, Giemsa: "gpos100", Chr: &Chr13}
	Chr13_q32_1  = genome.Band{Band: "q32.1", Desc: "Band", StartPos: 95000000, EndPos: 98200000, Giemsa: "gneg", Chr: &Chr13}
	Chr13_q32_2  = genome.Band{Band: "q32.2", Desc: "Band", StartPos: 98200000, EndPos: 99300000, Giemsa: "gpos25", Chr: &Chr13}
	Chr13_q32_3  = genome.Band{Band: "q32.3", Desc: "Band", StartPos: 99300000, EndPos: 101700000, Giemsa: "gneg", Chr: &Chr13}
	Chr13_q33_1  = genome.Band{Band: "q33.1", Desc: "Band", StartPos: 101700000, EndPos: 104800000, Giemsa: "gpos100", Chr: &Chr13}
	Chr13_q33_2  = genome.Band{Band: "q33.2", Desc: "Band", StartPos: 104800000, EndPos: 107000000, Giemsa: "gneg", Chr: &Chr13}
	Chr13_q33_3  = genome.Band{Band: "q33.3", Desc: "Band", StartPos: 107000000, EndPos: 110300000, Giemsa: "gpos100", Chr: &Chr13}
	Chr13_q34    = genome.Band{Band: "q34", Desc: "Band", StartPos: 110300000, EndPos: 115169878, Giemsa: "gneg", Chr: &Chr13}
	Chr14_p13    = genome.Band{Band: "p13", Desc: "Band", StartPos: 0, EndPos: 3700000, Giemsa: "gvar", Chr: &Chr14}
	Chr14_p12    = genome.Band{Band: "p12", Desc: "Band", StartPos: 3700000, EndPos: 8100000, Giemsa: "stalk", Chr: &Chr14}
	Chr14_p11_2  = genome.Band{Band: "p11.2", Desc: "Band", StartPos: 8100000, EndPos: 16100000, Giemsa: "gvar", Chr: &Chr14}
	Chr14_p11_1  = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 16100000, EndPos: 17600000, Giemsa: "acen", Chr: &Chr14}
	Chr14_q11_1  = genome.Band{Band: "q11.1", Desc: "Band", StartPos: 17600000, EndPos: 19100000, Giemsa: "acen", Chr: &Chr14}
	Chr14_q11_2  = genome.Band{Band: "q11.2", Desc: "Band", StartPos: 19100000, EndPos: 24600000, Giemsa: "gneg", Chr: &Chr14}
	Chr14_q12    = genome.Band{Band: "q12", Desc: "Band", StartPos: 24600000, EndPos: 33300000, Giemsa: "gpos100", Chr: &Chr14}
	Chr14_q13_1  = genome.Band{Band: "q13.1", Desc: "Band", StartPos: 33300000, EndPos: 35300000, Giemsa: "gneg", Chr: &Chr14}
	Chr14_q13_2  = genome.Band{Band: "q13.2", Desc: "Band", StartPos: 35300000, EndPos: 36600000, Giemsa: "gpos50", Chr: &Chr14}
	Chr14_q13_3  = genome.Band{Band: "q13.3", Desc: "Band", StartPos: 36600000, EndPos: 37800000, Giemsa: "gneg", Chr: &Chr14}
	Chr14_q21_1  = genome.Band{Band: "q21.1", Desc: "Band", StartPos: 37800000, EndPos: 43500000, Giemsa: "gpos100", Chr: &Chr14}
	Chr14_q21_2  = genome.Band{Band: "q21.2", Desc: "Band", StartPos: 43500000, EndPos: 47200000, Giemsa: "gneg", Chr: &Chr14}
	Chr14_q21_3  = genome.Band{Band: "q21.3", Desc: "Band", StartPos: 47200000, EndPos: 50900000, Giemsa: "gpos100", Chr: &Chr14}
	Chr14_q22_1  = genome.Band{Band: "q22.1", Desc: "Band", StartPos: 50900000, EndPos: 54100000, Giemsa: "gneg", Chr: &Chr14}
	Chr14_q22_2  = genome.Band{Band: "q22.2", Desc: "Band", StartPos: 54100000, EndPos: 55500000, Giemsa: "gpos25", Chr: &Chr14}
	Chr14_q22_3  = genome.Band{Band: "q22.3", Desc: "Band", StartPos: 55500000, EndPos: 58100000, Giemsa: "gneg", Chr: &Chr14}
	Chr14_q23_1  = genome.Band{Band: "q23.1", Desc: "Band", StartPos: 58100000, EndPos: 62100000, Giemsa: "gpos75", Chr: &Chr14}
	Chr14_q23_2  = genome.Band{Band: "q23.2", Desc: "Band", StartPos: 62100000, EndPos: 64800000, Giemsa: "gneg", Chr: &Chr14}
	Chr14_q23_3  = genome.Band{Band: "q23.3", Desc: "Band", StartPos: 64800000, EndPos: 67900000, Giemsa: "gpos50", Chr: &Chr14}
	Chr14_q24_1  = genome.Band{Band: "q24.1", Desc: "Band", StartPos: 67900000, EndPos: 70200000, Giemsa: "gneg", Chr: &Chr14}
	Chr14_q24_2  = genome.Band{Band: "q24.2", Desc: "Band", StartPos: 70200000, EndPos: 73800000, Giemsa: "gpos50", Chr: &Chr14}
	Chr14_q24_3  = genome.Band{Band: "q24.3", Desc: "Band", StartPos: 73800000, EndPos: 79300000, Giemsa: "gneg", Chr: &Chr14}
	Chr14_q31_1  = genome.Band{Band: "q31.1", Desc: "Band", StartPos: 79300000, EndPos: 83600000, Giemsa: "gpos100", Chr: &Chr14}
	Chr14_q31_2  = genome.Band{Band: "q31.2", Desc: "Band", StartPos: 83600000, EndPos: 84900000, Giemsa: "gneg", Chr: &Chr14}
	Chr14_q31_3  = genome.Band{Band: "q31.3", Desc: "Band", StartPos: 84900000, EndPos: 89800000, Giemsa: "gpos100", Chr: &Chr14}
	Chr14_q32_11 = genome.Band{Band: "q32.11", Desc: "Band", StartPos: 89800000, EndPos: 91900000, Giemsa: "gneg", Chr: &Chr14}
	Chr14_q32_12 = genome.Band{Band: "q32.12", Desc: "Band", StartPos: 91900000, EndPos: 94700000, Giemsa: "gpos25", Chr: &Chr14}
	Chr14_q32_13 = genome.Band{Band: "q32.13", Desc: "Band", StartPos: 94700000, EndPos: 96300000, Giemsa: "gneg", Chr: &Chr14}
	Chr14_q32_2  = genome.Band{Band: "q32.2", Desc: "Band", StartPos: 96300000, EndPos: 101400000, Giemsa: "gpos50", Chr: &Chr14}
	Chr14_q32_31 = genome.Band{Band: "q32.31", Desc: "Band", StartPos: 101400000, EndPos: 103200000, Giemsa: "gneg", Chr: &Chr14}
	Chr14_q32_32 = genome.Band{Band: "q32.32", Desc: "Band", StartPos: 103200000, EndPos: 104000000, Giemsa: "gpos50", Chr: &Chr14}
	Chr14_q32_33 = genome.Band{Band: "q32.33", Desc: "Band", StartPos: 104000000, EndPos: 107349540, Giemsa: "gneg", Chr: &Chr14}
	Chr15_p13    = genome.Band{Band: "p13", Desc: "Band", StartPos: 0, EndPos: 3900000, Giemsa: "gvar", Chr: &Chr15}
	Chr15_p12    = genome.Band{Band: "p12", Desc: "Band", StartPos: 3900000, EndPos: 8700000, Giemsa: "stalk", Chr: &Chr15}
	Chr15_p11_2  = genome.Band{Band: "p11.2", Desc: "Band", StartPos: 8700000, EndPos: 15800000, Giemsa: "gvar", Chr: &Chr15}
	Chr15_p11_1  = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 15800000, EndPos: 19000000, Giemsa: "acen", Chr: &Chr15}
	Chr15_q11_1  = genome.Band{Band: "q11.1", Desc: "Band", StartPos: 19000000, EndPos: 20700000, Giemsa: "acen", Chr: &Chr15}
	Chr15_q11_2  = genome.Band{Band: "q11.2", Desc: "Band", StartPos: 20700000, EndPos: 25700000, Giemsa: "gneg", Chr: &Chr15}
	Chr15_q12    = genome.Band{Band: "q12", Desc: "Band", StartPos: 25700000, EndPos: 28100000, Giemsa: "gpos50", Chr: &Chr15}
	Chr15_q13_1  = genome.Band{Band: "q13.1", Desc: "Band", StartPos: 28100000, EndPos: 30300000, Giemsa: "gneg", Chr: &Chr15}
	Chr15_q13_2  = genome.Band{Band: "q13.2", Desc: "Band", StartPos: 30300000, EndPos: 31200000, Giemsa: "gpos50", Chr: &Chr15}
	Chr15_q13_3  = genome.Band{Band: "q13.3", Desc: "Band", StartPos: 31200000, EndPos: 33600000, Giemsa: "gneg", Chr: &Chr15}
	Chr15_q14    = genome.Band{Band: "q14", Desc: "Band", StartPos: 33600000, EndPos: 40100000, Giemsa: "gpos75", Chr: &Chr15}
	Chr15_q15_1  = genome.Band{Band: "q15.1", Desc: "Band", StartPos: 40100000, EndPos: 42800000, Giemsa: "gneg", Chr: &Chr15}
	Chr15_q15_2  = genome.Band{Band: "q15.2", Desc: "Band", StartPos: 42800000, EndPos: 43600000, Giemsa: "gpos25", Chr: &Chr15}
	Chr15_q15_3  = genome.Band{Band: "q15.3", Desc: "Band", StartPos: 43600000, EndPos: 44800000, Giemsa: "gneg", Chr: &Chr15}
	Chr15_q21_1  = genome.Band{Band: "q21.1", Desc: "Band", StartPos: 44800000, EndPos: 49500000, Giemsa: "gpos75", Chr: &Chr15}
	Chr15_q21_2  = genome.Band{Band: "q21.2", Desc: "Band", StartPos: 49500000, EndPos: 52900000, Giemsa: "gneg", Chr: &Chr15}
	Chr15_q21_3  = genome.Band{Band: "q21.3", Desc: "Band", StartPos: 52900000, EndPos: 59100000, Giemsa: "gpos75", Chr: &Chr15}
	Chr15_q22_1  = genome.Band{Band: "q22.1", Desc: "Band", StartPos: 59100000, EndPos: 59300000, Giemsa: "gneg", Chr: &Chr15}
	Chr15_q22_2  = genome.Band{Band: "q22.2", Desc: "Band", StartPos: 59300000, EndPos: 63700000, Giemsa: "gpos25", Chr: &Chr15}
	Chr15_q22_31 = genome.Band{Band: "q22.31", Desc: "Band", StartPos: 63700000, EndPos: 67200000, Giemsa: "gneg", Chr: &Chr15}
	Chr15_q22_32 = genome.Band{Band: "q22.32", Desc: "Band", StartPos: 67200000, EndPos: 67300000, Giemsa: "gpos25", Chr: &Chr15}
	Chr15_q22_33 = genome.Band{Band: "q22.33", Desc: "Band", StartPos: 67300000, EndPos: 67500000, Giemsa: "gneg", Chr: &Chr15}
	Chr15_q23    = genome.Band{Band: "q23", Desc: "Band", StartPos: 67500000, EndPos: 72700000, Giemsa: "gpos25", Chr: &Chr15}
	Chr15_q24_1  = genome.Band{Band: "q24.1", Desc: "Band", StartPos: 72700000, EndPos: 75200000, Giemsa: "gneg", Chr: &Chr15}
	Chr15_q24_2  = genome.Band{Band: "q24.2", Desc: "Band", StartPos: 75200000, EndPos: 76600000, Giemsa: "gpos25", Chr: &Chr15}
	Chr15_q24_3  = genome.Band{Band: "q24.3", Desc: "Band", StartPos: 76600000, EndPos: 78300000, Giemsa: "gneg", Chr: &Chr15}
	Chr15_q25_1  = genome.Band{Band: "q25.1", Desc: "Band", StartPos: 78300000, EndPos: 81700000, Giemsa: "gpos50", Chr: &Chr15}
	Chr15_q25_2  = genome.Band{Band: "q25.2", Desc: "Band", StartPos: 81700000, EndPos: 85200000, Giemsa: "gneg", Chr: &Chr15}
	Chr15_q25_3  = genome.Band{Band: "q25.3", Desc: "Band", StartPos: 85200000, EndPos: 89100000, Giemsa: "gpos50", Chr: &Chr15}
	Chr15_q26_1  = genome.Band{Band: "q26.1", Desc: "Band", StartPos: 89100000, EndPos: 94300000, Giemsa: "gneg", Chr: &Chr15}
	Chr15_q26_2  = genome.Band{Band: "q26.2", Desc: "Band", StartPos: 94300000, EndPos: 98500000, Giemsa: "gpos50", Chr: &Chr15}
	Chr15_q26_3  = genome.Band{Band: "q26.3", Desc: "Band", StartPos: 98500000, EndPos: 102531392, Giemsa: "gneg", Chr: &Chr15}
	Chr16_p13_3  = genome.Band{Band: "p13.3", Desc: "Band", StartPos: 0, EndPos: 7900000, Giemsa: "gneg", Chr: &Chr16}
	Chr16_p13_2  = genome.Band{Band: "p13.2", Desc: "Band", StartPos: 7900000, EndPos: 10500000, Giemsa: "gpos50", Chr: &Chr16}
	Chr16_p13_13 = genome.Band{Band: "p13.13", Desc: "Band", StartPos: 10500000, EndPos: 12600000, Giemsa: "gneg", Chr: &Chr16}
	Chr16_p13_12 = genome.Band{Band: "p13.12", Desc: "Band", StartPos: 12600000, EndPos: 14800000, Giemsa: "gpos50", Chr: &Chr16}
	Chr16_p13_11 = genome.Band{Band: "p13.11", Desc: "Band", StartPos: 14800000, EndPos: 16800000, Giemsa: "gneg", Chr: &Chr16}
	Chr16_p12_3  = genome.Band{Band: "p12.3", Desc: "Band", StartPos: 16800000, EndPos: 21200000, Giemsa: "gpos50", Chr: &Chr16}
	Chr16_p12_2  = genome.Band{Band: "p12.2", Desc: "Band", StartPos: 21200000, EndPos: 24200000, Giemsa: "gneg", Chr: &Chr16}
	Chr16_p12_1  = genome.Band{Band: "p12.1", Desc: "Band", StartPos: 24200000, EndPos: 28100000, Giemsa: "gpos50", Chr: &Chr16}
	Chr16_p11_2  = genome.Band{Band: "p11.2", Desc: "Band", StartPos: 28100000, EndPos: 34600000, Giemsa: "gneg", Chr: &Chr16}
	Chr16_p11_1  = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 34600000, EndPos: 36600000, Giemsa: "acen", Chr: &Chr16}
	Chr16_q11_1  = genome.Band{Band: "q11.1", Desc: "Band", StartPos: 36600000, EndPos: 38600000, Giemsa: "acen", Chr: &Chr16}
	Chr16_q11_2  = genome.Band{Band: "q11.2", Desc: "Band", StartPos: 38600000, EndPos: 47000000, Giemsa: "gvar", Chr: &Chr16}
	Chr16_q12_1  = genome.Band{Band: "q12.1", Desc: "Band", StartPos: 47000000, EndPos: 52600000, Giemsa: "gneg", Chr: &Chr16}
	Chr16_q12_2  = genome.Band{Band: "q12.2", Desc: "Band", StartPos: 52600000, EndPos: 56700000, Giemsa: "gpos50", Chr: &Chr16}
	Chr16_q13    = genome.Band{Band: "q13", Desc: "Band", StartPos: 56700000, EndPos: 57400000, Giemsa: "gneg", Chr: &Chr16}
	Chr16_q21    = genome.Band{Band: "q21", Desc: "Band", StartPos: 57400000, EndPos: 66700000, Giemsa: "gpos100", Chr: &Chr16}
	Chr16_q22_1  = genome.Band{Band: "q22.1", Desc: "Band", StartPos: 66700000, EndPos: 70800000, Giemsa: "gneg", Chr: &Chr16}
	Chr16_q22_2  = genome.Band{Band: "q22.2", Desc: "Band", StartPos: 70800000, EndPos: 72900000, Giemsa: "gpos50", Chr: &Chr16}
	Chr16_q22_3  = genome.Band{Band: "q22.3", Desc: "Band", StartPos: 72900000, EndPos: 74100000, Giemsa: "gneg", Chr: &Chr16}
	Chr16_q23_1  = genome.Band{Band: "q23.1", Desc: "Band", StartPos: 74100000, EndPos: 79200000, Giemsa: "gpos75", Chr: &Chr16}
	Chr16_q23_2  = genome.Band{Band: "q23.2", Desc: "Band", StartPos: 79200000, EndPos: 81700000, Giemsa: "gneg", Chr: &Chr16}
	Chr16_q23_3  = genome.Band{Band: "q23.3", Desc: "Band", StartPos: 81700000, EndPos: 84200000, Giemsa: "gpos50", Chr: &Chr16}
	Chr16_q24_1  = genome.Band{Band: "q24.1", Desc: "Band", StartPos: 84200000, EndPos: 87100000, Giemsa: "gneg", Chr: &Chr16}
	Chr16_q24_2  = genome.Band{Band: "q24.2", Desc: "Band", StartPos: 87100000, EndPos: 88700000, Giemsa: "gpos25", Chr: &Chr16}
	Chr16_q24_3  = genome.Band{Band: "q24.3", Desc: "Band", StartPos: 88700000, EndPos: 90354753, Giemsa: "gneg", Chr: &Chr16}
	Chr17_p13_3  = genome.Band{Band: "p13.3", Desc: "Band", StartPos: 0, EndPos: 3300000, Giemsa: "gneg", Chr: &Chr17}
	Chr17_p13_2  = genome.Band{Band: "p13.2", Desc: "Band", StartPos: 3300000, EndPos: 6500000, Giemsa: "gpos50", Chr: &Chr17}
	Chr17_p13_1  = genome.Band{Band: "p13.1", Desc: "Band", StartPos: 6500000, EndPos: 10700000, Giemsa: "gneg", Chr: &Chr17}
	Chr17_p12    = genome.Band{Band: "p12", Desc: "Band", StartPos: 10700000, EndPos: 16000000, Giemsa: "gpos75", Chr: &Chr17}
	Chr17_p11_2  = genome.Band{Band: "p11.2", Desc: "Band", StartPos: 16000000, EndPos: 22200000, Giemsa: "gneg", Chr: &Chr17}
	Chr17_p11_1  = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 22200000, EndPos: 24000000, Giemsa: "acen", Chr: &Chr17}
	Chr17_q11_1  = genome.Band{Band: "q11.1", Desc: "Band", StartPos: 24000000, EndPos: 25800000, Giemsa: "acen", Chr: &Chr17}
	Chr17_q11_2  = genome.Band{Band: "q11.2", Desc: "Band", StartPos: 25800000, EndPos: 31800000, Giemsa: "gneg", Chr: &Chr17}
	Chr17_q12    = genome.Band{Band: "q12", Desc: "Band", StartPos: 31800000, EndPos: 38100000, Giemsa: "gpos50", Chr: &Chr17}
	Chr17_q21_1  = genome.Band{Band: "q21.1", Desc: "Band", StartPos: 38100000, EndPos: 38400000, Giemsa: "gneg", Chr: &Chr17}
	Chr17_q21_2  = genome.Band{Band: "q21.2", Desc: "Band", StartPos: 38400000, EndPos: 40900000, Giemsa: "gpos25", Chr: &Chr17}
	Chr17_q21_31 = genome.Band{Band: "q21.31", Desc: "Band", StartPos: 40900000, EndPos: 44900000, Giemsa: "gneg", Chr: &Chr17}
	Chr17_q21_32 = genome.Band{Band: "q21.32", Desc: "Band", StartPos: 44900000, EndPos: 47400000, Giemsa: "gpos25", Chr: &Chr17}
	Chr17_q21_33 = genome.Band{Band: "q21.33", Desc: "Band", StartPos: 47400000, EndPos: 50200000, Giemsa: "gneg", Chr: &Chr17}
	Chr17_q22    = genome.Band{Band: "q22", Desc: "Band", StartPos: 50200000, EndPos: 57600000, Giemsa: "gpos75", Chr: &Chr17}
	Chr17_q23_1  = genome.Band{Band: "q23.1", Desc: "Band", StartPos: 57600000, EndPos: 58300000, Giemsa: "gneg", Chr: &Chr17}
	Chr17_q23_2  = genome.Band{Band: "q23.2", Desc: "Band", StartPos: 58300000, EndPos: 61100000, Giemsa: "gpos75", Chr: &Chr17}
	Chr17_q23_3  = genome.Band{Band: "q23.3", Desc: "Band", StartPos: 61100000, EndPos: 62600000, Giemsa: "gneg", Chr: &Chr17}
	Chr17_q24_1  = genome.Band{Band: "q24.1", Desc: "Band", StartPos: 62600000, EndPos: 64200000, Giemsa: "gpos50", Chr: &Chr17}
	Chr17_q24_2  = genome.Band{Band: "q24.2", Desc: "Band", StartPos: 64200000, EndPos: 67100000, Giemsa: "gneg", Chr: &Chr17}
	Chr17_q24_3  = genome.Band{Band: "q24.3", Desc: "Band", StartPos: 67100000, EndPos: 70900000, Giemsa: "gpos75", Chr: &Chr17}
	Chr17_q25_1  = genome.Band{Band: "q25.1", Desc: "Band", StartPos: 70900000, EndPos: 74800000, Giemsa: "gneg", Chr: &Chr17}
	Chr17_q25_2  = genome.Band{Band: "q25.2", Desc: "Band", StartPos: 74800000, EndPos: 75300000, Giemsa: "gpos25", Chr: &Chr17}
	Chr17_q25_3  = genome.Band{Band: "q25.3", Desc: "Band", StartPos: 75300000, EndPos: 81195210, Giemsa: "gneg", Chr: &Chr17}
	Chr18_p11_32 = genome.Band{Band: "p11.32", Desc: "Band", StartPos: 0, EndPos: 2900000, Giemsa: "gneg", Chr: &Chr18}
	Chr18_p11_31 = genome.Band{Band: "p11.31", Desc: "Band", StartPos: 2900000, EndPos: 7100000, Giemsa: "gpos50", Chr: &Chr18}
	Chr18_p11_23 = genome.Band{Band: "p11.23", Desc: "Band", StartPos: 7100000, EndPos: 8500000, Giemsa: "gneg", Chr: &Chr18}
	Chr18_p11_22 = genome.Band{Band: "p11.22", Desc: "Band", StartPos: 8500000, EndPos: 10900000, Giemsa: "gpos25", Chr: &Chr18}
	Chr18_p11_21 = genome.Band{Band: "p11.21", Desc: "Band", StartPos: 10900000, EndPos: 15400000, Giemsa: "gneg", Chr: &Chr18}
	Chr18_p11_1  = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 15400000, EndPos: 17200000, Giemsa: "acen", Chr: &Chr18}
	Chr18_q11_1  = genome.Band{Band: "q11.1", Desc: "Band", StartPos: 17200000, EndPos: 19000000, Giemsa: "acen", Chr: &Chr18}
	Chr18_q11_2  = genome.Band{Band: "q11.2", Desc: "Band", StartPos: 19000000, EndPos: 25000000, Giemsa: "gneg", Chr: &Chr18}
	Chr18_q12_1  = genome.Band{Band: "q12.1", Desc: "Band", StartPos: 25000000, EndPos: 32700000, Giemsa: "gpos100", Chr: &Chr18}
	Chr18_q12_2  = genome.Band{Band: "q12.2", Desc: "Band", StartPos: 32700000, EndPos: 37200000, Giemsa: "gneg", Chr: &Chr18}
	Chr18_q12_3  = genome.Band{Band: "q12.3", Desc: "Band", StartPos: 37200000, EndPos: 43500000, Giemsa: "gpos75", Chr: &Chr18}
	Chr18_q21_1  = genome.Band{Band: "q21.1", Desc: "Band", StartPos: 43500000, EndPos: 48200000, Giemsa: "gneg", Chr: &Chr18}
	Chr18_q21_2  = genome.Band{Band: "q21.2", Desc: "Band", StartPos: 48200000, EndPos: 53800000, Giemsa: "gpos75", Chr: &Chr18}
	Chr18_q21_31 = genome.Band{Band: "q21.31", Desc: "Band", StartPos: 53800000, EndPos: 56200000, Giemsa: "gneg", Chr: &Chr18}
	Chr18_q21_32 = genome.Band{Band: "q21.32", Desc: "Band", StartPos: 56200000, EndPos: 59000000, Giemsa: "gpos50", Chr: &Chr18}
	Chr18_q21_33 = genome.Band{Band: "q21.33", Desc: "Band", StartPos: 59000000, EndPos: 61600000, Giemsa: "gneg", Chr: &Chr18}
	Chr18_q22_1  = genome.Band{Band: "q22.1", Desc: "Band", StartPos: 61600000, EndPos: 66800000, Giemsa: "gpos100", Chr: &Chr18}
	Chr18_q22_2  = genome.Band{Band: "q22.2", Desc: "Band", StartPos: 66800000, EndPos: 68700000, Giemsa: "gneg", Chr: &Chr18}
	Chr18_q22_3  = genome.Band{Band: "q22.3", Desc: "Band", StartPos: 68700000, EndPos: 73100000, Giemsa: "gpos25", Chr: &Chr18}
	Chr18_q23    = genome.Band{Band: "q23", Desc: "Band", StartPos: 73100000, EndPos: 78077248, Giemsa: "gneg", Chr: &Chr18}
	Chr19_p13_3  = genome.Band{Band: "p13.3", Desc: "Band", StartPos: 0, EndPos: 6900000, Giemsa: "gneg", Chr: &Chr19}
	Chr19_p13_2  = genome.Band{Band: "p13.2", Desc: "Band", StartPos: 6900000, EndPos: 13900000, Giemsa: "gpos25", Chr: &Chr19}
	Chr19_p13_13 = genome.Band{Band: "p13.13", Desc: "Band", StartPos: 13900000, EndPos: 14000000, Giemsa: "gneg", Chr: &Chr19}
	Chr19_p13_12 = genome.Band{Band: "p13.12", Desc: "Band", StartPos: 14000000, EndPos: 16300000, Giemsa: "gpos25", Chr: &Chr19}
	Chr19_p13_11 = genome.Band{Band: "p13.11", Desc: "Band", StartPos: 16300000, EndPos: 20000000, Giemsa: "gneg", Chr: &Chr19}
	Chr19_p12    = genome.Band{Band: "p12", Desc: "Band", StartPos: 20000000, EndPos: 24400000, Giemsa: "gvar", Chr: &Chr19}
	Chr19_p11    = genome.Band{Band: "p11", Desc: "Band", StartPos: 24400000, EndPos: 26500000, Giemsa: "acen", Chr: &Chr19}
	Chr19_q11    = genome.Band{Band: "q11", Desc: "Band", StartPos: 26500000, EndPos: 28600000, Giemsa: "acen", Chr: &Chr19}
	Chr19_q12    = genome.Band{Band: "q12", Desc: "Band", StartPos: 28600000, EndPos: 32400000, Giemsa: "gvar", Chr: &Chr19}
	Chr19_q13_11 = genome.Band{Band: "q13.11", Desc: "Band", StartPos: 32400000, EndPos: 35500000, Giemsa: "gneg", Chr: &Chr19}
	Chr19_q13_12 = genome.Band{Band: "q13.12", Desc: "Band", StartPos: 35500000, EndPos: 38300000, Giemsa: "gpos25", Chr: &Chr19}
	Chr19_q13_13 = genome.Band{Band: "q13.13", Desc: "Band", StartPos: 38300000, EndPos: 38700000, Giemsa: "gneg", Chr: &Chr19}
	Chr19_q13_2  = genome.Band{Band: "q13.2", Desc: "Band", StartPos: 38700000, EndPos: 43400000, Giemsa: "gpos25", Chr: &Chr19}
	Chr19_q13_31 = genome.Band{Band: "q13.31", Desc: "Band", StartPos: 43400000, EndPos: 45200000, Giemsa: "gneg", Chr: &Chr19}
	Chr19_q13_32 = genome.Band{Band: "q13.32", Desc: "Band", StartPos: 45200000, EndPos: 48000000, Giemsa: "gpos25", Chr: &Chr19}
	Chr19_q13_33 = genome.Band{Band: "q13.33", Desc: "Band", StartPos: 48000000, EndPos: 51400000, Giemsa: "gneg", Chr: &Chr19}
	Chr19_q13_41 = genome.Band{Band: "q13.41", Desc: "Band", StartPos: 51400000, EndPos: 53600000, Giemsa: "gpos25", Chr: &Chr19}
	Chr19_q13_42 = genome.Band{Band: "q13.42", Desc: "Band", StartPos: 53600000, EndPos: 56300000, Giemsa: "gneg", Chr: &Chr19}
	Chr19_q13_43 = genome.Band{Band: "q13.43", Desc: "Band", StartPos: 56300000, EndPos: 59128983, Giemsa: "gpos25", Chr: &Chr19}
	Chr20_p13    = genome.Band{Band: "p13", Desc: "Band", StartPos: 0, EndPos: 5100000, Giemsa: "gneg", Chr: &Chr20}
	Chr20_p12_3  = genome.Band{Band: "p12.3", Desc: "Band", StartPos: 5100000, EndPos: 9200000, Giemsa: "gpos75", Chr: &Chr20}
	Chr20_p12_2  = genome.Band{Band: "p12.2", Desc: "Band", StartPos: 9200000, EndPos: 12100000, Giemsa: "gneg", Chr: &Chr20}
	Chr20_p12_1  = genome.Band{Band: "p12.1", Desc: "Band", StartPos: 12100000, EndPos: 17900000, Giemsa: "gpos75", Chr: &Chr20}
	Chr20_p11_23 = genome.Band{Band: "p11.23", Desc: "Band", StartPos: 17900000, EndPos: 21300000, Giemsa: "gneg", Chr: &Chr20}
	Chr20_p11_22 = genome.Band{Band: "p11.22", Desc: "Band", StartPos: 21300000, EndPos: 22300000, Giemsa: "gpos25", Chr: &Chr20}
	Chr20_p11_21 = genome.Band{Band: "p11.21", Desc: "Band", StartPos: 22300000, EndPos: 25600000, Giemsa: "gneg", Chr: &Chr20}
	Chr20_p11_1  = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 25600000, EndPos: 27500000, Giemsa: "acen", Chr: &Chr20}
	Chr20_q11_1  = genome.Band{Band: "q11.1", Desc: "Band", StartPos: 27500000, EndPos: 29400000, Giemsa: "acen", Chr: &Chr20}
	Chr20_q11_21 = genome.Band{Band: "q11.21", Desc: "Band", StartPos: 29400000, EndPos: 32100000, Giemsa: "gneg", Chr: &Chr20}
	Chr20_q11_22 = genome.Band{Band: "q11.22", Desc: "Band", StartPos: 32100000, EndPos: 34400000, Giemsa: "gpos25", Chr: &Chr20}
	Chr20_q11_23 = genome.Band{Band: "q11.23", Desc: "Band", StartPos: 34400000, EndPos: 37600000, Giemsa: "gneg", Chr: &Chr20}
	Chr20_q12    = genome.Band{Band: "q12", Desc: "Band", StartPos: 37600000, EndPos: 41700000, Giemsa: "gpos75", Chr: &Chr20}
	Chr20_q13_11 = genome.Band{Band: "q13.11", Desc: "Band", StartPos: 41700000, EndPos: 42100000, Giemsa: "gneg", Chr: &Chr20}
	Chr20_q13_12 = genome.Band{Band: "q13.12", Desc: "Band", StartPos: 42100000, EndPos: 46400000, Giemsa: "gpos25", Chr: &Chr20}
	Chr20_q13_13 = genome.Band{Band: "q13.13", Desc: "Band", StartPos: 46400000, EndPos: 49800000, Giemsa: "gneg", Chr: &Chr20}
	Chr20_q13_2  = genome.Band{Band: "q13.2", Desc: "Band", StartPos: 49800000, EndPos: 55000000, Giemsa: "gpos75", Chr: &Chr20}
	Chr20_q13_31 = genome.Band{Band: "q13.31", Desc: "Band", StartPos: 55000000, EndPos: 56500000, Giemsa: "gneg", Chr: &Chr20}
	Chr20_q13_32 = genome.Band{Band: "q13.32", Desc: "Band", StartPos: 56500000, EndPos: 58400000, Giemsa: "gpos50", Chr: &Chr20}
	Chr20_q13_33 = genome.Band{Band: "q13.33", Desc: "Band", StartPos: 58400000, EndPos: 63025520, Giemsa: "gneg", Chr: &Chr20}
	Chr21_p13    = genome.Band{Band: "p13", Desc: "Band", StartPos: 0, EndPos: 2800000, Giemsa: "gvar", Chr: &Chr21}
	Chr21_p12    = genome.Band{Band: "p12", Desc: "Band", StartPos: 2800000, EndPos: 6800000, Giemsa: "stalk", Chr: &Chr21}
	Chr21_p11_2  = genome.Band{Band: "p11.2", Desc: "Band", StartPos: 6800000, EndPos: 10900000, Giemsa: "gvar", Chr: &Chr21}
	Chr21_p11_1  = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 10900000, EndPos: 13200000, Giemsa: "acen", Chr: &Chr21}
	Chr21_q11_1  = genome.Band{Band: "q11.1", Desc: "Band", StartPos: 13200000, EndPos: 14300000, Giemsa: "acen", Chr: &Chr21}
	Chr21_q11_2  = genome.Band{Band: "q11.2", Desc: "Band", StartPos: 14300000, EndPos: 16400000, Giemsa: "gneg", Chr: &Chr21}
	Chr21_q21_1  = genome.Band{Band: "q21.1", Desc: "Band", StartPos: 16400000, EndPos: 24000000, Giemsa: "gpos100", Chr: &Chr21}
	Chr21_q21_2  = genome.Band{Band: "q21.2", Desc: "Band", StartPos: 24000000, EndPos: 26800000, Giemsa: "gneg", Chr: &Chr21}
	Chr21_q21_3  = genome.Band{Band: "q21.3", Desc: "Band", StartPos: 26800000, EndPos: 31500000, Giemsa: "gpos75", Chr: &Chr21}
	Chr21_q22_11 = genome.Band{Band: "q22.11", Desc: "Band", StartPos: 31500000, EndPos: 35800000, Giemsa: "gneg", Chr: &Chr21}
	Chr21_q22_12 = genome.Band{Band: "q22.12", Desc: "Band", StartPos: 35800000, EndPos: 37800000, Giemsa: "gpos50", Chr: &Chr21}
	Chr21_q22_13 = genome.Band{Band: "q22.13", Desc: "Band", StartPos: 37800000, EndPos: 39700000, Giemsa: "gneg", Chr: &Chr21}
	Chr21_q22_2  = genome.Band{Band: "q22.2", Desc: "Band", StartPos: 39700000, EndPos: 42600000, Giemsa: "gpos50", Chr: &Chr21}
	Chr21_q22_3  = genome.Band{Band: "q22.3", Desc: "Band", StartPos: 42600000, EndPos: 48129895, Giemsa: "gneg", Chr: &Chr21}
	Chr22_p13    = genome.Band{Band: "p13", Desc: "Band", StartPos: 0, EndPos: 3800000, Giemsa: "gvar", Chr: &Chr22}
	Chr22_p12    = genome.Band{Band: "p12", Desc: "Band", StartPos: 3800000, EndPos: 8300000, Giemsa: "stalk", Chr: &Chr22}
	Chr22_p11_2  = genome.Band{Band: "p11.2", Desc: "Band", StartPos: 8300000, EndPos: 12200000, Giemsa: "gvar", Chr: &Chr22}
	Chr22_p11_1  = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 12200000, EndPos: 14700000, Giemsa: "acen", Chr: &Chr22}
	Chr22_q11_1  = genome.Band{Band: "q11.1", Desc: "Band", StartPos: 14700000, EndPos: 17900000, Giemsa: "acen", Chr: &Chr22}
	Chr22_q11_21 = genome.Band{Band: "q11.21", Desc: "Band", StartPos: 17900000, EndPos: 22200000, Giemsa: "gneg", Chr: &Chr22}
	Chr22_q11_22 = genome.Band{Band: "q11.22", Desc: "Band", StartPos: 22200000, EndPos: 23500000, Giemsa: "gpos25", Chr: &Chr22}
	Chr22_q11_23 = genome.Band{Band: "q11.23", Desc: "Band", StartPos: 23500000, EndPos: 25900000, Giemsa: "gneg", Chr: &Chr22}
	Chr22_q12_1  = genome.Band{Band: "q12.1", Desc: "Band", StartPos: 25900000, EndPos: 29600000, Giemsa: "gpos50", Chr: &Chr22}
	Chr22_q12_2  = genome.Band{Band: "q12.2", Desc: "Band", StartPos: 29600000, EndPos: 32200000, Giemsa: "gneg", Chr: &Chr22}
	Chr22_q12_3  = genome.Band{Band: "q12.3", Desc: "Band", StartPos: 32200000, EndPos: 37600000, Giemsa: "gpos50", Chr: &Chr22}
	Chr22_q13_1  = genome.Band{Band: "q13.1", Desc: "Band", StartPos: 37600000, EndPos: 41000000, Giemsa: "gneg", Chr: &Chr22}
	Chr22_q13_2  = genome.Band{Band: "q13.2", Desc: "Band", StartPos: 41000000, EndPos: 44200000, Giemsa: "gpos50", Chr: &Chr22}
	Chr22_q13_31 = genome.Band{Band: "q13.31", Desc: "Band", StartPos: 44200000, EndPos: 48400000, Giemsa: "gneg", Chr: &Chr22}
	Chr22_q13_32 = genome.Band{Band: "q13.32", Desc: "Band", StartPos: 48400000, EndPos: 49400000, Giemsa: "gpos50", Chr: &Chr22}
	Chr22_q13_33 = genome.Band{Band: "q13.33", Desc: "Band", StartPos: 49400000, EndPos: 51304566, Giemsa: "gneg", Chr: &Chr22}
	ChrX_p22_33  = genome.Band{Band: "p22.33", Desc: "Band", StartPos: 0, EndPos: 4300000, Giemsa: "gneg", Chr: &ChrX}
	ChrX_p22_32  = genome.Band{Band: "p22.32", Desc: "Band", StartPos: 4300000, EndPos: 6000000, Giemsa: "gpos50", Chr: &ChrX}
	ChrX_p22_31  = genome.Band{Band: "p22.31", Desc: "Band", StartPos: 6000000, EndPos: 9500000, Giemsa: "gneg", Chr: &ChrX}
	ChrX_p22_2   = genome.Band{Band: "p22.2", Desc: "Band", StartPos: 9500000, EndPos: 17100000, Giemsa: "gpos50", Chr: &ChrX}
	ChrX_p22_13  = genome.Band{Band: "p22.13", Desc: "Band", StartPos: 17100000, EndPos: 19300000, Giemsa: "gneg", Chr: &ChrX}
	ChrX_p22_12  = genome.Band{Band: "p22.12", Desc: "Band", StartPos: 19300000, EndPos: 21900000, Giemsa: "gpos50", Chr: &ChrX}
	ChrX_p22_11  = genome.Band{Band: "p22.11", Desc: "Band", StartPos: 21900000, EndPos: 24900000, Giemsa: "gneg", Chr: &ChrX}
	ChrX_p21_3   = genome.Band{Band: "p21.3", Desc: "Band", StartPos: 24900000, EndPos: 29300000, Giemsa: "gpos100", Chr: &ChrX}
	ChrX_p21_2   = genome.Band{Band: "p21.2", Desc: "Band", StartPos: 29300000, EndPos: 31500000, Giemsa: "gneg", Chr: &ChrX}
	ChrX_p21_1   = genome.Band{Band: "p21.1", Desc: "Band", StartPos: 31500000, EndPos: 37600000, Giemsa: "gpos100", Chr: &ChrX}
	ChrX_p11_4   = genome.Band{Band: "p11.4", Desc: "Band", StartPos: 37600000, EndPos: 42400000, Giemsa: "gneg", Chr: &ChrX}
	ChrX_p11_3   = genome.Band{Band: "p11.3", Desc: "Band", StartPos: 42400000, EndPos: 46400000, Giemsa: "gpos75", Chr: &ChrX}
	ChrX_p11_23  = genome.Band{Band: "p11.23", Desc: "Band", StartPos: 46400000, EndPos: 49800000, Giemsa: "gneg", Chr: &ChrX}
	ChrX_p11_22  = genome.Band{Band: "p11.22", Desc: "Band", StartPos: 49800000, EndPos: 54800000, Giemsa: "gpos25", Chr: &ChrX}
	ChrX_p11_21  = genome.Band{Band: "p11.21", Desc: "Band", StartPos: 54800000, EndPos: 58100000, Giemsa: "gneg", Chr: &ChrX}
	ChrX_p11_1   = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 58100000, EndPos: 60600000, Giemsa: "acen", Chr: &ChrX}
	ChrX_q11_1   = genome.Band{Band: "q11.1", Desc: "Band", StartPos: 60600000, EndPos: 63000000, Giemsa: "acen", Chr: &ChrX}
	ChrX_q11_2   = genome.Band{Band: "q11.2", Desc: "Band", StartPos: 63000000, EndPos: 64600000, Giemsa: "gneg", Chr: &ChrX}
	ChrX_q12     = genome.Band{Band: "q12", Desc: "Band", StartPos: 64600000, EndPos: 67800000, Giemsa: "gpos50", Chr: &ChrX}
	ChrX_q13_1   = genome.Band{Band: "q13.1", Desc: "Band", StartPos: 67800000, EndPos: 71800000, Giemsa: "gneg", Chr: &ChrX}
	ChrX_q13_2   = genome.Band{Band: "q13.2", Desc: "Band", StartPos: 71800000, EndPos: 73900000, Giemsa: "gpos50", Chr: &ChrX}
	ChrX_q13_3   = genome.Band{Band: "q13.3", Desc: "Band", StartPos: 73900000, EndPos: 76000000, Giemsa: "gneg", Chr: &ChrX}
	ChrX_q21_1   = genome.Band{Band: "q21.1", Desc: "Band", StartPos: 76000000, EndPos: 84600000, Giemsa: "gpos100", Chr: &ChrX}
	ChrX_q21_2   = genome.Band{Band: "q21.2", Desc: "Band", StartPos: 84600000, EndPos: 86200000, Giemsa: "gneg", Chr: &ChrX}
	ChrX_q21_31  = genome.Band{Band: "q21.31", Desc: "Band", StartPos: 86200000, EndPos: 91800000, Giemsa: "gpos100", Chr: &ChrX}
	ChrX_q21_32  = genome.Band{Band: "q21.32", Desc: "Band", StartPos: 91800000, EndPos: 93500000, Giemsa: "gneg", Chr: &ChrX}
	ChrX_q21_33  = genome.Band{Band: "q21.33", Desc: "Band", StartPos: 93500000, EndPos: 98300000, Giemsa: "gpos75", Chr: &ChrX}
	ChrX_q22_1   = genome.Band{Band: "q22.1", Desc: "Band", StartPos: 98300000, EndPos: 102600000, Giemsa: "gneg", Chr: &ChrX}
	ChrX_q22_2   = genome.Band{Band: "q22.2", Desc: "Band", StartPos: 102600000, EndPos: 103700000, Giemsa: "gpos50", Chr: &ChrX}
	ChrX_q22_3   = genome.Band{Band: "q22.3", Desc: "Band", StartPos: 103700000, EndPos: 108700000, Giemsa: "gneg", Chr: &ChrX}
	ChrX_q23     = genome.Band{Band: "q23", Desc: "Band", StartPos: 108700000, EndPos: 116500000, Giemsa: "gpos75", Chr: &ChrX}
	ChrX_q24     = genome.Band{Band: "q24", Desc: "Band", StartPos: 116500000, EndPos: 120900000, Giemsa: "gneg", Chr: &ChrX}
	ChrX_q25     = genome.Band{Band: "q25", Desc: "Band", StartPos: 120900000, EndPos: 128700000, Giemsa: "gpos100", Chr: &ChrX}
	ChrX_q26_1   = genome.Band{Band: "q26.1", Desc: "Band", StartPos: 128700000, EndPos: 130400000, Giemsa: "gneg", Chr: &ChrX}
	ChrX_q26_2   = genome.Band{Band: "q26.2", Desc: "Band", StartPos: 130400000, EndPos: 133600000, Giemsa: "gpos25", Chr: &ChrX}
	ChrX_q26_3   = genome.Band{Band: "q26.3", Desc: "Band", StartPos: 133600000, EndPos: 138000000, Giemsa: "gneg", Chr: &ChrX}
	ChrX_q27_1   = genome.Band{Band: "q27.1", Desc: "Band", StartPos: 138000000, EndPos: 140300000, Giemsa: "gpos75", Chr: &ChrX}
	ChrX_q27_2   = genome.Band{Band: "q27.2", Desc: "Band", StartPos: 140300000, EndPos: 142100000, Giemsa: "gneg", Chr: &ChrX}
	ChrX_q27_3   = genome.Band{Band: "q27.3", Desc: "Band", StartPos: 142100000, EndPos: 147100000, Giemsa: "gpos100", Chr: &ChrX}
	ChrX_q28     = genome.Band{Band: "q28", Desc: "Band", StartPos: 147100000, EndPos: 155270560, Giemsa: "gneg", Chr: &ChrX}
	ChrY_p11_32  = genome.Band{Band: "p11.32", Desc: "Band", StartPos: 0, EndPos: 2500000, Giemsa: "gneg", Chr: &ChrY}
	ChrY_p11_31  = genome.Band{Band: "p11.31", Desc: "Band", StartPos: 2500000, EndPos: 3000000, Giemsa: "gpos50", Chr: &ChrY}
	ChrY_p11_2   = genome.Band{Band: "p11.2", Desc: "Band", StartPos: 3000000, EndPos: 11600000, Giemsa: "gneg", Chr: &ChrY}
	ChrY_p11_1   = genome.Band{Band: "p11.1", Desc: "Band", StartPos: 11600000, EndPos: 12500000, Giemsa: "acen", Chr: &ChrY}
	ChrY_q11_1   = genome.Band{Band: "q11.1", Desc: "Band", StartPos: 12500000, EndPos: 13400000, Giemsa: "acen", Chr: &ChrY}
	ChrY_q11_21  = genome.Band{Band: "q11.21", Desc: "Band", StartPos: 13400000, EndPos: 15100000, Giemsa: "gneg", Chr: &ChrY}
	ChrY_q11_221 = genome.Band{Band: "q11.221", Desc: "Band", StartPos: 15100000, EndPos: 19800000, Giemsa: "gpos50", Chr: &ChrY}
	ChrY_q11_222 = genome.Band{Band: "q11.222", Desc: "Band", StartPos: 19800000, EndPos: 22100000, Giemsa: "gneg", Chr: &ChrY}
	ChrY_q11_223 = genome.Band{Band: "q11.223", Desc: "Band", StartPos: 22100000, EndPos: 26200000, Giemsa: "gpos50", Chr: &ChrY}
	ChrY_q11_23  = genome.Band{Band: "q11.23", Desc: "Band", StartPos: 26200000, EndPos: 28800000, Giemsa: "gneg", Chr: &ChrY}
	ChrY_q12     = genome.Band{Band: "q12", Desc: "Band", StartPos: 28800000, EndPos: 59373566, Giemsa: "gvar", Chr: &ChrY}
)

var Bands = []*genome.Band{
	&Chr1_p36_33,
	&Chr1_p36_32,
	&Chr1_p36_31,
	&Chr1_p36_23,
	&Chr1_p36_22,
	&Chr1_p36_21,
	&Chr1_p36_13,
	&Chr1_p36_12,
	&Chr1_p36_11,
	&Chr1_p35_3,
	&Chr1_p35_2,
	&Chr1_p35_1,
	&Chr1_p34_3,
	&Chr1_p34_2,
	&Chr1_p34_1,
	&Chr1_p33,
	&Chr1_p32_3,
	&Chr1_p32_2,
	&Chr1_p32_1,
	&Chr1_p31_3,
	&Chr1_p31_2,
	&Chr1_p31_1,
	&Chr1_p22_3,
	&Chr1_p22_2,
	&Chr1_p22_1,
	&Chr1_p21_3,
	&Chr1_p21_2,
	&Chr1_p21_1,
	&Chr1_p13_3,
	&Chr1_p13_2,
	&Chr1_p13_1,
	&Chr1_p12,
	&Chr1_p11_2,
	&Chr1_p11_1,
	&Chr1_q11,
	&Chr1_q12,
	&Chr1_q21_1,
	&Chr1_q21_2,
	&Chr1_q21_3,
	&Chr1_q22,
	&Chr1_q23_1,
	&Chr1_q23_2,
	&Chr1_q23_3,
	&Chr1_q24_1,
	&Chr1_q24_2,
	&Chr1_q24_3,
	&Chr1_q25_1,
	&Chr1_q25_2,
	&Chr1_q25_3,
	&Chr1_q31_1,
	&Chr1_q31_2,
	&Chr1_q31_3,
	&Chr1_q32_1,
	&Chr1_q32_2,
	&Chr1_q32_3,
	&Chr1_q41,
	&Chr1_q42_11,
	&Chr1_q42_12,
	&Chr1_q42_13,
	&Chr1_q42_2,
	&Chr1_q42_3,
	&Chr1_q43,
	&Chr1_q44,
	&Chr2_p25_3,
	&Chr2_p25_2,
	&Chr2_p25_1,
	&Chr2_p24_3,
	&Chr2_p24_2,
	&Chr2_p24_1,
	&Chr2_p23_3,
	&Chr2_p23_2,
	&Chr2_p23_1,
	&Chr2_p22_3,
	&Chr2_p22_2,
	&Chr2_p22_1,
	&Chr2_p21,
	&Chr2_p16_3,
	&Chr2_p16_2,
	&Chr2_p16_1,
	&Chr2_p15,
	&Chr2_p14,
	&Chr2_p13_3,
	&Chr2_p13_2,
	&Chr2_p13_1,
	&Chr2_p12,
	&Chr2_p11_2,
	&Chr2_p11_1,
	&Chr2_q11_1,
	&Chr2_q11_2,
	&Chr2_q12_1,
	&Chr2_q12_2,
	&Chr2_q12_3,
	&Chr2_q13,
	&Chr2_q14_1,
	&Chr2_q14_2,
	&Chr2_q14_3,
	&Chr2_q21_1,
	&Chr2_q21_2,
	&Chr2_q21_3,
	&Chr2_q22_1,
	&Chr2_q22_2,
	&Chr2_q22_3,
	&Chr2_q23_1,
	&Chr2_q23_2,
	&Chr2_q23_3,
	&Chr2_q24_1,
	&Chr2_q24_2,
	&Chr2_q24_3,
	&Chr2_q31_1,
	&Chr2_q31_2,
	&Chr2_q31_3,
	&Chr2_q32_1,
	&Chr2_q32_2,
	&Chr2_q32_3,
	&Chr2_q33_1,
	&Chr2_q33_2,
	&Chr2_q33_3,
	&Chr2_q34,
	&Chr2_q35,
	&Chr2_q36_1,
	&Chr2_q36_2,
	&Chr2_q36_3,
	&Chr2_q37_1,
	&Chr2_q37_2,
	&Chr2_q37_3,
	&Chr3_p26_3,
	&Chr3_p26_2,
	&Chr3_p26_1,
	&Chr3_p25_3,
	&Chr3_p25_2,
	&Chr3_p25_1,
	&Chr3_p24_3,
	&Chr3_p24_2,
	&Chr3_p24_1,
	&Chr3_p23,
	&Chr3_p22_3,
	&Chr3_p22_2,
	&Chr3_p22_1,
	&Chr3_p21_33,
	&Chr3_p21_32,
	&Chr3_p21_31,
	&Chr3_p21_2,
	&Chr3_p21_1,
	&Chr3_p14_3,
	&Chr3_p14_2,
	&Chr3_p14_1,
	&Chr3_p13,
	&Chr3_p12_3,
	&Chr3_p12_2,
	&Chr3_p12_1,
	&Chr3_p11_2,
	&Chr3_p11_1,
	&Chr3_q11_1,
	&Chr3_q11_2,
	&Chr3_q12_1,
	&Chr3_q12_2,
	&Chr3_q12_3,
	&Chr3_q13_11,
	&Chr3_q13_12,
	&Chr3_q13_13,
	&Chr3_q13_2,
	&Chr3_q13_31,
	&Chr3_q13_32,
	&Chr3_q13_33,
	&Chr3_q21_1,
	&Chr3_q21_2,
	&Chr3_q21_3,
	&Chr3_q22_1,
	&Chr3_q22_2,
	&Chr3_q22_3,
	&Chr3_q23,
	&Chr3_q24,
	&Chr3_q25_1,
	&Chr3_q25_2,
	&Chr3_q25_31,
	&Chr3_q25_32,
	&Chr3_q25_33,
	&Chr3_q26_1,
	&Chr3_q26_2,
	&Chr3_q26_31,
	&Chr3_q26_32,
	&Chr3_q26_33,
	&Chr3_q27_1,
	&Chr3_q27_2,
	&Chr3_q27_3,
	&Chr3_q28,
	&Chr3_q29,
	&Chr4_p16_3,
	&Chr4_p16_2,
	&Chr4_p16_1,
	&Chr4_p15_33,
	&Chr4_p15_32,
	&Chr4_p15_31,
	&Chr4_p15_2,
	&Chr4_p15_1,
	&Chr4_p14,
	&Chr4_p13,
	&Chr4_p12,
	&Chr4_p11,
	&Chr4_q11,
	&Chr4_q12,
	&Chr4_q13_1,
	&Chr4_q13_2,
	&Chr4_q13_3,
	&Chr4_q21_1,
	&Chr4_q21_21,
	&Chr4_q21_22,
	&Chr4_q21_23,
	&Chr4_q21_3,
	&Chr4_q22_1,
	&Chr4_q22_2,
	&Chr4_q22_3,
	&Chr4_q23,
	&Chr4_q24,
	&Chr4_q25,
	&Chr4_q26,
	&Chr4_q27,
	&Chr4_q28_1,
	&Chr4_q28_2,
	&Chr4_q28_3,
	&Chr4_q31_1,
	&Chr4_q31_21,
	&Chr4_q31_22,
	&Chr4_q31_23,
	&Chr4_q31_3,
	&Chr4_q32_1,
	&Chr4_q32_2,
	&Chr4_q32_3,
	&Chr4_q33,
	&Chr4_q34_1,
	&Chr4_q34_2,
	&Chr4_q34_3,
	&Chr4_q35_1,
	&Chr4_q35_2,
	&Chr5_p15_33,
	&Chr5_p15_32,
	&Chr5_p15_31,
	&Chr5_p15_2,
	&Chr5_p15_1,
	&Chr5_p14_3,
	&Chr5_p14_2,
	&Chr5_p14_1,
	&Chr5_p13_3,
	&Chr5_p13_2,
	&Chr5_p13_1,
	&Chr5_p12,
	&Chr5_p11,
	&Chr5_q11_1,
	&Chr5_q11_2,
	&Chr5_q12_1,
	&Chr5_q12_2,
	&Chr5_q12_3,
	&Chr5_q13_1,
	&Chr5_q13_2,
	&Chr5_q13_3,
	&Chr5_q14_1,
	&Chr5_q14_2,
	&Chr5_q14_3,
	&Chr5_q15,
	&Chr5_q21_1,
	&Chr5_q21_2,
	&Chr5_q21_3,
	&Chr5_q22_1,
	&Chr5_q22_2,
	&Chr5_q22_3,
	&Chr5_q23_1,
	&Chr5_q23_2,
	&Chr5_q23_3,
	&Chr5_q31_1,
	&Chr5_q31_2,
	&Chr5_q31_3,
	&Chr5_q32,
	&Chr5_q33_1,
	&Chr5_q33_2,
	&Chr5_q33_3,
	&Chr5_q34,
	&Chr5_q35_1,
	&Chr5_q35_2,
	&Chr5_q35_3,
	&Chr6_p25_3,
	&Chr6_p25_2,
	&Chr6_p25_1,
	&Chr6_p24_3,
	&Chr6_p24_2,
	&Chr6_p24_1,
	&Chr6_p23,
	&Chr6_p22_3,
	&Chr6_p22_2,
	&Chr6_p22_1,
	&Chr6_p21_33,
	&Chr6_p21_32,
	&Chr6_p21_31,
	&Chr6_p21_2,
	&Chr6_p21_1,
	&Chr6_p12_3,
	&Chr6_p12_2,
	&Chr6_p12_1,
	&Chr6_p11_2,
	&Chr6_p11_1,
	&Chr6_q11_1,
	&Chr6_q11_2,
	&Chr6_q12,
	&Chr6_q13,
	&Chr6_q14_1,
	&Chr6_q14_2,
	&Chr6_q14_3,
	&Chr6_q15,
	&Chr6_q16_1,
	&Chr6_q16_2,
	&Chr6_q16_3,
	&Chr6_q21,
	&Chr6_q22_1,
	&Chr6_q22_2,
	&Chr6_q22_31,
	&Chr6_q22_32,
	&Chr6_q22_33,
	&Chr6_q23_1,
	&Chr6_q23_2,
	&Chr6_q23_3,
	&Chr6_q24_1,
	&Chr6_q24_2,
	&Chr6_q24_3,
	&Chr6_q25_1,
	&Chr6_q25_2,
	&Chr6_q25_3,
	&Chr6_q26,
	&Chr6_q27,
	&Chr7_p22_3,
	&Chr7_p22_2,
	&Chr7_p22_1,
	&Chr7_p21_3,
	&Chr7_p21_2,
	&Chr7_p21_1,
	&Chr7_p15_3,
	&Chr7_p15_2,
	&Chr7_p15_1,
	&Chr7_p14_3,
	&Chr7_p14_2,
	&Chr7_p14_1,
	&Chr7_p13,
	&Chr7_p12_3,
	&Chr7_p12_2,
	&Chr7_p12_1,
	&Chr7_p11_2,
	&Chr7_p11_1,
	&Chr7_q11_1,
	&Chr7_q11_21,
	&Chr7_q11_22,
	&Chr7_q11_23,
	&Chr7_q21_11,
	&Chr7_q21_12,
	&Chr7_q21_13,
	&Chr7_q21_2,
	&Chr7_q21_3,
	&Chr7_q22_1,
	&Chr7_q22_2,
	&Chr7_q22_3,
	&Chr7_q31_1,
	&Chr7_q31_2,
	&Chr7_q31_31,
	&Chr7_q31_32,
	&Chr7_q31_33,
	&Chr7_q32_1,
	&Chr7_q32_2,
	&Chr7_q32_3,
	&Chr7_q33,
	&Chr7_q34,
	&Chr7_q35,
	&Chr7_q36_1,
	&Chr7_q36_2,
	&Chr7_q36_3,
	&Chr8_p23_3,
	&Chr8_p23_2,
	&Chr8_p23_1,
	&Chr8_p22,
	&Chr8_p21_3,
	&Chr8_p21_2,
	&Chr8_p21_1,
	&Chr8_p12,
	&Chr8_p11_23,
	&Chr8_p11_22,
	&Chr8_p11_21,
	&Chr8_p11_1,
	&Chr8_q11_1,
	&Chr8_q11_21,
	&Chr8_q11_22,
	&Chr8_q11_23,
	&Chr8_q12_1,
	&Chr8_q12_2,
	&Chr8_q12_3,
	&Chr8_q13_1,
	&Chr8_q13_2,
	&Chr8_q13_3,
	&Chr8_q21_11,
	&Chr8_q21_12,
	&Chr8_q21_13,
	&Chr8_q21_2,
	&Chr8_q21_3,
	&Chr8_q22_1,
	&Chr8_q22_2,
	&Chr8_q22_3,
	&Chr8_q23_1,
	&Chr8_q23_2,
	&Chr8_q23_3,
	&Chr8_q24_11,
	&Chr8_q24_12,
	&Chr8_q24_13,
	&Chr8_q24_21,
	&Chr8_q24_22,
	&Chr8_q24_23,
	&Chr8_q24_3,
	&Chr9_p24_3,
	&Chr9_p24_2,
	&Chr9_p24_1,
	&Chr9_p23,
	&Chr9_p22_3,
	&Chr9_p22_2,
	&Chr9_p22_1,
	&Chr9_p21_3,
	&Chr9_p21_2,
	&Chr9_p21_1,
	&Chr9_p13_3,
	&Chr9_p13_2,
	&Chr9_p13_1,
	&Chr9_p12,
	&Chr9_p11_2,
	&Chr9_p11_1,
	&Chr9_q11,
	&Chr9_q12,
	&Chr9_q13,
	&Chr9_q21_11,
	&Chr9_q21_12,
	&Chr9_q21_13,
	&Chr9_q21_2,
	&Chr9_q21_31,
	&Chr9_q21_32,
	&Chr9_q21_33,
	&Chr9_q22_1,
	&Chr9_q22_2,
	&Chr9_q22_31,
	&Chr9_q22_32,
	&Chr9_q22_33,
	&Chr9_q31_1,
	&Chr9_q31_2,
	&Chr9_q31_3,
	&Chr9_q32,
	&Chr9_q33_1,
	&Chr9_q33_2,
	&Chr9_q33_3,
	&Chr9_q34_11,
	&Chr9_q34_12,
	&Chr9_q34_13,
	&Chr9_q34_2,
	&Chr9_q34_3,
	&Chr10_p15_3,
	&Chr10_p15_2,
	&Chr10_p15_1,
	&Chr10_p14,
	&Chr10_p13,
	&Chr10_p12_33,
	&Chr10_p12_32,
	&Chr10_p12_31,
	&Chr10_p12_2,
	&Chr10_p12_1,
	&Chr10_p11_23,
	&Chr10_p11_22,
	&Chr10_p11_21,
	&Chr10_p11_1,
	&Chr10_q11_1,
	&Chr10_q11_21,
	&Chr10_q11_22,
	&Chr10_q11_23,
	&Chr10_q21_1,
	&Chr10_q21_2,
	&Chr10_q21_3,
	&Chr10_q22_1,
	&Chr10_q22_2,
	&Chr10_q22_3,
	&Chr10_q23_1,
	&Chr10_q23_2,
	&Chr10_q23_31,
	&Chr10_q23_32,
	&Chr10_q23_33,
	&Chr10_q24_1,
	&Chr10_q24_2,
	&Chr10_q24_31,
	&Chr10_q24_32,
	&Chr10_q24_33,
	&Chr10_q25_1,
	&Chr10_q25_2,
	&Chr10_q25_3,
	&Chr10_q26_11,
	&Chr10_q26_12,
	&Chr10_q26_13,
	&Chr10_q26_2,
	&Chr10_q26_3,
	&Chr11_p15_5,
	&Chr11_p15_4,
	&Chr11_p15_3,
	&Chr11_p15_2,
	&Chr11_p15_1,
	&Chr11_p14_3,
	&Chr11_p14_2,
	&Chr11_p14_1,
	&Chr11_p13,
	&Chr11_p12,
	&Chr11_p11_2,
	&Chr11_p11_12,
	&Chr11_p11_11,
	&Chr11_q11,
	&Chr11_q12_1,
	&Chr11_q12_2,
	&Chr11_q12_3,
	&Chr11_q13_1,
	&Chr11_q13_2,
	&Chr11_q13_3,
	&Chr11_q13_4,
	&Chr11_q13_5,
	&Chr11_q14_1,
	&Chr11_q14_2,
	&Chr11_q14_3,
	&Chr11_q21,
	&Chr11_q22_1,
	&Chr11_q22_2,
	&Chr11_q22_3,
	&Chr11_q23_1,
	&Chr11_q23_2,
	&Chr11_q23_3,
	&Chr11_q24_1,
	&Chr11_q24_2,
	&Chr11_q24_3,
	&Chr11_q25,
	&Chr12_p13_33,
	&Chr12_p13_32,
	&Chr12_p13_31,
	&Chr12_p13_2,
	&Chr12_p13_1,
	&Chr12_p12_3,
	&Chr12_p12_2,
	&Chr12_p12_1,
	&Chr12_p11_23,
	&Chr12_p11_22,
	&Chr12_p11_21,
	&Chr12_p11_1,
	&Chr12_q11,
	&Chr12_q12,
	&Chr12_q13_11,
	&Chr12_q13_12,
	&Chr12_q13_13,
	&Chr12_q13_2,
	&Chr12_q13_3,
	&Chr12_q14_1,
	&Chr12_q14_2,
	&Chr12_q14_3,
	&Chr12_q15,
	&Chr12_q21_1,
	&Chr12_q21_2,
	&Chr12_q21_31,
	&Chr12_q21_32,
	&Chr12_q21_33,
	&Chr12_q22,
	&Chr12_q23_1,
	&Chr12_q23_2,
	&Chr12_q23_3,
	&Chr12_q24_11,
	&Chr12_q24_12,
	&Chr12_q24_13,
	&Chr12_q24_21,
	&Chr12_q24_22,
	&Chr12_q24_23,
	&Chr12_q24_31,
	&Chr12_q24_32,
	&Chr12_q24_33,
	&Chr13_p13,
	&Chr13_p12,
	&Chr13_p11_2,
	&Chr13_p11_1,
	&Chr13_q11,
	&Chr13_q12_11,
	&Chr13_q12_12,
	&Chr13_q12_13,
	&Chr13_q12_2,
	&Chr13_q12_3,
	&Chr13_q13_1,
	&Chr13_q13_2,
	&Chr13_q13_3,
	&Chr13_q14_11,
	&Chr13_q14_12,
	&Chr13_q14_13,
	&Chr13_q14_2,
	&Chr13_q14_3,
	&Chr13_q21_1,
	&Chr13_q21_2,
	&Chr13_q21_31,
	&Chr13_q21_32,
	&Chr13_q21_33,
	&Chr13_q22_1,
	&Chr13_q22_2,
	&Chr13_q22_3,
	&Chr13_q31_1,
	&Chr13_q31_2,
	&Chr13_q31_3,
	&Chr13_q32_1,
	&Chr13_q32_2,
	&Chr13_q32_3,
	&Chr13_q33_1,
	&Chr13_q33_2,
	&Chr13_q33_3,
	&Chr13_q34,
	&Chr14_p13,
	&Chr14_p12,
	&Chr14_p11_2,
	&Chr14_p11_1,
	&Chr14_q11_1,
	&Chr14_q11_2,
	&Chr14_q12,
	&Chr14_q13_1,
	&Chr14_q13_2,
	&Chr14_q13_3,
	&Chr14_q21_1,
	&Chr14_q21_2,
	&Chr14_q21_3,
	&Chr14_q22_1,
	&Chr14_q22_2,
	&Chr14_q22_3,
	&Chr14_q23_1,
	&Chr14_q23_2,
	&Chr14_q23_3,
	&Chr14_q24_1,
	&Chr14_q24_2,
	&Chr14_q24_3,
	&Chr14_q31_1,
	&Chr14_q31_2,
	&Chr14_q31_3,
	&Chr14_q32_11,
	&Chr14_q32_12,
	&Chr14_q32_13,
	&Chr14_q32_2,
	&Chr14_q32_31,
	&Chr14_q32_32,
	&Chr14_q32_33,
	&Chr15_p13,
	&Chr15_p12,
	&Chr15_p11_2,
	&Chr15_p11_1,
	&Chr15_q11_1,
	&Chr15_q11_2,
	&Chr15_q12,
	&Chr15_q13_1,
	&Chr15_q13_2,
	&Chr15_q13_3,
	&Chr15_q14,
	&Chr15_q15_1,
	&Chr15_q15_2,
	&Chr15_q15_3,
	&Chr15_q21_1,
	&Chr15_q21_2,
	&Chr15_q21_3,
	&Chr15_q22_1,
	&Chr15_q22_2,
	&Chr15_q22_31,
	&Chr15_q22_32,
	&Chr15_q22_33,
	&Chr15_q23,
	&Chr15_q24_1,
	&Chr15_q24_2,
	&Chr15_q24_3,
	&Chr15_q25_1,
	&Chr15_q25_2,
	&Chr15_q25_3,
	&Chr15_q26_1,
	&Chr15_q26_2,
	&Chr15_q26_3,
	&Chr16_p13_3,
	&Chr16_p13_2,
	&Chr16_p13_13,
	&Chr16_p13_12,
	&Chr16_p13_11,
	&Chr16_p12_3,
	&Chr16_p12_2,
	&Chr16_p12_1,
	&Chr16_p11_2,
	&Chr16_p11_1,
	&Chr16_q11_1,
	&Chr16_q11_2,
	&Chr16_q12_1,
	&Chr16_q12_2,
	&Chr16_q13,
	&Chr16_q21,
	&Chr16_q22_1,
	&Chr16_q22_2,
	&Chr16_q22_3,
	&Chr16_q23_1,
	&Chr16_q23_2,
	&Chr16_q23_3,
	&Chr16_q24_1,
	&Chr16_q24_2,
	&Chr16_q24_3,
	&Chr17_p13_3,
	&Chr17_p13_2,
	&Chr17_p13_1,
	&Chr17_p12,
	&Chr17_p11_2,
	&Chr17_p11_1,
	&Chr17_q11_1,
	&Chr17_q11_2,
	&Chr17_q12,
	&Chr17_q21_1,
	&Chr17_q21_2,
	&Chr17_q21_31,
	&Chr17_q21_32,
	&Chr17_q21_33,
	&Chr17_q22,
	&Chr17_q23_1,
	&Chr17_q23_2,
	&Chr17_q23_3,
	&Chr17_q24_1,
	&Chr17_q24_2,
	&Chr17_q24_3,
	&Chr17_q25_1,
	&Chr17_q25_2,
	&Chr17_q25_3,
	&Chr18_p11_32,
	&Chr18_p11_31,
	&Chr18_p11_23,
	&Chr18_p11_22,
	&Chr18_p11_21,
	&Chr18_p11_1,
	&Chr18_q11_1,
	&Chr18_q11_2,
	&Chr18_q12_1,
	&Chr18_q12_2,
	&Chr18_q12_3,
	&Chr18_q21_1,
	&Chr18_q21_2,
	&Chr18_q21_31,
	&Chr18_q21_32,
	&Chr18_q21_33,
	&Chr18_q22_1,
	&Chr18_q22_2,
	&Chr18_q22_3,
	&Chr18_q23,
	&Chr19_p13_3,
	&Chr19_p13_2,
	&Chr19_p13_13,
	&Chr19_p13_12,
	&Chr19_p13_11,
	&Chr19_p12,
	&Chr19_p11,
	&Chr19_q11,
	&Chr19_q12,
	&Chr19_q13_11,
	&Chr19_q13_12,
	&Chr19_q13_13,
	&Chr19_q13_2,
	&Chr19_q13_31,
	&Chr19_q13_32,
	&Chr19_q13_33,
	&Chr19_q13_41,
	&Chr19_q13_42,
	&Chr19_q13_43,
	&Chr20_p13,
	&Chr20_p12_3,
	&Chr20_p12_2,
	&Chr20_p12_1,
	&Chr20_p11_23,
	&Chr20_p11_22,
	&Chr20_p11_21,
	&Chr20_p11_1,
	&Chr20_q11_1,
	&Chr20_q11_21,
	&Chr20_q11_22,
	&Chr20_q11_23,
	&Chr20_q12,
	&Chr20_q13_11,
	&Chr20_q13_12,
	&Chr20_q13_13,
	&Chr20_q13_2,
	&Chr20_q13_31,
	&Chr20_q13_32,
	&Chr20_q13_33,
	&Chr21_p13,
	&Chr21_p12,
	&Chr21_p11_2,
	&Chr21_p11_1,
	&Chr21_q11_1,
	&Chr21_q11_2,
	&Chr21_q21_1,
	&Chr21_q21_2,
	&Chr21_q21_3,
	&Chr21_q22_11,
	&Chr21_q22_12,
	&Chr21_q22_13,
	&Chr21_q22_2,
	&Chr21_q22_3,
	&Chr22_p13,
	&Chr22_p12,
	&Chr22_p11_2,
	&Chr22_p11_1,
	&Chr22_q11_1,
	&Chr22_q11_21,
	&Chr22_q11_22,
	&Chr22_q11_23,
	&Chr22_q12_1,
	&Chr22_q12_2,
	&Chr22_q12_3,
	&Chr22_q13_1,
	&Chr22_q13_2,
	&Chr22_q13_31,
	&Chr22_q13_32,
	&Chr22_q13_33,
	&ChrX_p22_33,
	&ChrX_p22_32,
	&ChrX_p22_31,
	&ChrX_p22_2,
	&ChrX_p22_13,
	&ChrX_p22_12,
	&ChrX_p22_11,
	&ChrX_p21_3,
	&ChrX_p21_2,
	&ChrX_p21_1,
	&ChrX_p11_4,
	&ChrX_p11_3,
	&ChrX_p11_23,
	&ChrX_p11_22,
	&ChrX_p11_21,
	&ChrX_p11_1,
	&ChrX_q11_1,
	&ChrX_q11_2,
	&ChrX_q12,
	&ChrX_q13_1,
	&ChrX_q13_2,
	&ChrX_q13_3,
	&ChrX_q21_1,
	&ChrX_q21_2,
	&ChrX_q21_31,
	&ChrX_q21_32,
	&ChrX_q21_33,
	&ChrX_q22_1,
	&ChrX_q22_2,
	&ChrX_q22_3,
	&ChrX_q23,
	&ChrX_q24,
	&ChrX_q25,
	&ChrX_q26_1,
	&ChrX_q26_2,
	&ChrX_q26_3,
	&ChrX_q27_1,
	&ChrX_q27_2,
	&ChrX_q27_3,
	&ChrX_q28,
	&ChrY_p11_32,
	&ChrY_p11_31,
	&ChrY_p11_2,
	&ChrY_p11_1,
	&ChrY_q11_1,
	&ChrY_q11_21,
	&ChrY_q11_221,
	&ChrY_q11_222,
	&ChrY_q11_223,
	&ChrY_q11_23,
	&ChrY_q12,
}

//line parse.karyotype:82
func init() {
	for _, b := range Bands {
		b.Chr.(*genome.Chromosome).Features = append(b.Chr.(*genome.Chromosome).Features, b)
	}
	for _, c := range Chromosomes {
		bc := make([]feat.Feature, len(c.Features))
		copy(bc, c.Features)
		c.Features = bc
	}
}
